#!/usr/bin/perl

################################################################################
#     Beomdori's Link v2.3+
#
#     Programmer : BeomGyu, Lee
#     E-Mail     : cadeau@orgio.net
#     Homepage   : http://beomdori.x-y.net
#
################################################################################

require "./lib/cm_get_supervisor_config.cgi";
&get_supervisor_config;
################################################################################

umask(000);       
&parseArgument;

sub parseArgument {
    require "./lib/cm_parse2.cgi";
    require "./lib/cm_alert.cgi";
    require "./lib/cm_html_head.cgi";
    
    local($msg);

    &parse2;
    
    if($FORM{'db'}) {
    	$gBaseDIR = "./db/$FORM{'db'}";
        $gNumFile = "$FORM{'db'}_num.cgi";
        $gCfgFile = "$FORM{'db'}_cfg.cgi";
        $gPwdFile = "$FORM{'db'}_pwd.cgi";
        $gDatFile = "$FORM{'db'}_dat.cgi";
    }
    else {
        $msg = "ũϴ  : \"http\:\/\/\~\/bdr_link.cgi?db=DB\"Դϴ.     "; 
        alert($msg);
    }
    
    if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
        close(HANDLE);   
            
        require "./lib/cm_check_bdr_cgi.cgi";
        &check_bdr_cgi("bdr_link");
        &selectAction;
    }
    else {
        require "./lib/cm_get_cookie.cgi";    	
        &get_cookie;    	    	        

        require "./lib/cm_check_password.cgi";        
        if(&check_supervisor_password("$COOKIE{'ROOTADMIN'}") eq "true") {        	
           &selectAction;
        }
        else {
           $msg = "ڸ DB   ֽϴ."; 
           alert($msg);        	        	
        }
    }
}

sub selectAction {
    require "./lib/cm_check_member.cgi";
    require "./lib/cm_check_password.cgi";
    require "./lib/cm_get_cookie.cgi";
    require "./lib/cm_get_num_info.cgi";
	
    &get_num_info;
    &get_config_variables;
    &get_cookie;
    
    unless($FORM{'action'}) {
        $FORM{'action'} = "r";
    }
    
    # ȸ 
    if($gUserType eq "type_member") {

         #  ȯ漳 ޴
         if($FORM{'action'} eq "admin_login") {
            if(&check_supervisor_password("$COOKIE{'ROOTADMIN'}") eq "true") {
                 &show_config_form;         		
            }
            else {
                 &show_admin_login;
            }           	
         }
         elsif($FORM{'action'} eq "show_config_form") {
                &check_admin_password;
                &show_config_form;
         }
         elsif($FORM{'action'} eq "config") {
                &update_config_variables;
         }
         # αǾ  α 
         elsif( !-e "./members/logon/$COOKIE{'MEMBER_ID'}.cgi" ) {
               &check_member;
         }
         # Ÿ 밡 ɵ
         else {         
             if($FORM{'action'} eq "r") {	
	        &read_data;
             } 
             elsif($FORM{'action'} eq "show_input_form") {
                    &check_admin_password;
	            &show_admin_input_form;
             }
             elsif($FORM{'action'} eq "show_user_input_form") {
                    if($gUserUp eq "checked") {
                      &show_user_input_form;
                    }
             }
             elsif($FORM{'action'} eq "write") {
                  &write_data;
             } 
             elsif($FORM{'action'} eq "delete") {
                    &check_user_password;
	            &delete_data;
             } 
             elsif($FORM{'action'} eq "show_update_form") {
                    &check_user_password;
	            &show_update_form;
             } 
             elsif($FORM{'action'} eq "update") {
    	            &update_data;
             } 
             elsif($FORM{'action'} eq "users_login") {
                    &show_user_ogin;
             }
             elsif($FORM{'action'} eq "search") {
                    if(($gLinkType eq "0") || ($gLinkType eq "weblink")) {
	               &search_data_for_WebLink;
                    }
                    elsif(($gLinkType eq "1") || ($gLinkType eq "linklist")) {
           	           &search_data_for_LinkList;
                     }
             }
             else {
                 exit;
             }
         }
    }
    # Ϲ 
    else {
         if($FORM{'action'} eq "r") {	
	    &read_data;
         } 
         elsif($FORM{'action'} eq "show_input_form") {
                &check_admin_password;
	        &show_admin_input_form;
         }
         elsif($FORM{'action'} eq "show_user_input_form") {
               if($gUserUp eq "checked") {
                 &show_user_input_form;
               }
         }
         elsif($FORM{'action'} eq "write") {
	         &write_data;
         } 
         elsif($FORM{'action'} eq "delete") {
                 &check_user_password;
	         &delete_data;
         } 
         elsif($FORM{'action'} eq "login") {
                 &check_member;
         }        
         elsif($FORM{'action'} eq "show_update_form") {
                 &check_user_password;
	         &show_update_form;
         } 
         elsif($FORM{'action'} eq "update") {
	         &update_data;
         } 
         elsif($FORM{'action'} eq "users_login") {
                 &show_user_ogin;
         }
         elsif($FORM{'action'} eq "admin_login") {
            if(&check_supervisor_password("$COOKIE{'ROOTADMIN'}") eq "true") {
                  &show_config_form;         		
            }
            else {
                  &show_admin_login;
            }           	
         }
         elsif($FORM{'action'} eq "show_config_form") {
                &check_admin_password;
                &show_config_form;
         }
         elsif($FORM{'action'} eq "config") {
                &update_config_variables;
         }
         elsif($FORM{'action'} eq "search") {
                if(($gLinkType eq "0") || ($gLinkType eq "weblink")) {
	            &search_data_for_WebLink;
                }
                elsif(($gLinkType eq "1") || ($gLinkType eq "linklist")) {
           	    &search_data_for_LinkList;
                 }
         }
         else {
             exit;
         }    	
    }
}

##########################################################################
# bdr_link ȯ漳 оδ.
##########################################################################
sub get_config_variables {
    local($env_list);
    local(@datum);

    if(open(HANDLE,"<$gBaseDIR/$gCfgFile")) {
        $env_list = <HANDLE>;
        close(HANDLE);
        @datum = split(/\|/,$env_list);

        $gBackColor = $datum[1];
        $gBackImgURL = $datum[2];
        $gTitleText = $datum[3];
        
        $gLinkType = $datum[12];   # ũŸ : 0. ũ    1. ũƮ
        
        $gRecPerPage = $datum[6];
        $gListNumber = $datum[7];

        $gTitleUse = $datum[11];

        $gTableWidth = $datum[5];
        $gTableTapText = $datum[13];
        $gTableTapBgcolor = $datum[27];        
        $gTableBgcolor = $datum[21];
        $gTableText = $datum[15];
        $gActiveTableColor = $datum[14];
        
        $gItem = $datum[28];
        $gItem1 = $datum[29];
        $gItem2 = $datum[30];
        $gItem3 = $datum[31];
        $gItem4 = $datum[32];
        $gItem5 = $datum[33];
        $gItem6 = $datum[10];                        
        $gItem7 = $datum[22];        
        $gItem8 = $datum[23];        

        $gUserUp = $datum[34];
        $gTextColor = $datum[17];

        $gAlignType = $datum[26];        # Display Ĺ
        $gUserType = $datum[20];        # Ÿ : Ϲ type_normal, ȸ type_member
        $gBannerLocation = $datum[35];        

        $gPreviewWidth = $datum[8];
        $gPreviewBgcolor = $datum[9];
        $gPreviewTextcolor = $datum[18];     
                
        $gTempURL2 = $datum[4];           
        $gTempColor4 = $datum[16];
        $gTempYesOrNo1 = $datum[19];        
        $gTempYesOrNo2 = $datum[24];
        $gShowIPInfo = $datum[25];
        $gTempYesOrNo4 = $datum[36];        

        chop($gHomeImageURL);
    }
    else {
        # ʱ ȯ 

        $gBackColor = "#ffffff";
        $gBackImgURL = "./img/link/bg.gif";

        $gLinkType = "weblink";           # ũŸ : 0. ũ    1. ũƮ
                
        $gTitleText = "Web Link";
        $gTitleUse = "YES";

        $gTableWidth = "95%";
        $gTableTapText = "#ffffff";        
        $gTableTapBgcolor = "#494949";
        $gTableBgcolor = "#ffffff";
        $gTableText = "#000000";
        $gActiveTableColor = "#f5f5f5";
        $gTextColor = "#000000";

        $gRecPerPage = "10";
        $gListNumber = "5";

        $gItem = "0";
        $gItem1 = "";
        $gItem2 = "";
        $gItem3 = "";
        $gItem4 = "";
        $gItem5 = "";
        $gItem6 = "";                        
        $gItem7 = "";        
        $gItem8 = "";
        
        $gUserUp = "checked";              #  Ⱑ(NO )
        $gAlignType = "center";
        $gUserType = "type_normal";
        $gBannerLocation = "right";        
  
        $gPreviewWidth = "300";
        $gPreviewBgcolor = "#cccccc";        
        $gPreviewTextcolor = "#000000";      
        
        $gTempColor4 = "#000000";        
        $gTempYesOrNo1 = "YES";
        $gTempYesOrNo2 = "YES";
        $gShowIPInfo = "YES";
        $gTempYesOrNo4 = "YES";
        $gTempURL2 = "";
        
        &putEnvVar;
    }
}

##########################################################################
# bdr_link ȯ漳 ȭϿ Ѵ.
########################################################################## 
sub putEnvVar {
    require "./lib/cm_lock.cgi";

    &lock("$FORM{'db'}_cfg");    	
    open(HANDLE,">$gBaseDIR/$gCfgFile");
        print HANDLE "^^|$gBackColor|$gBackImgURL|$gTitleText|$gTempURL2|$gTableWidth|$gRecPerPage|$gListNumber|$gPreviewWidth|$gPreviewBgcolor|$gItem6|$gTitleUse|$gLinkType|$gTableTapText|$gActiveTableColor|$gTableText|$gTempColor4|$gTextColor|$gPreviewTextcolor|$gTempYesOrNo1|$gUserType|$gTableBgcolor|$gItem7|$gItem8|$gTempYesOrNo2|$gShowIPInfo|$gAlignType|$gTableTapBgcolor|$gItem|$gItem1|$gItem2|$gItem3|$gItem4|$gItem5|$gUserUp|$gBannerLocation|$gTempYesOrNo4|\n";
    close(HANDLE);
    &unlock("$FORM{'db'}_cfg");    
}

##########################################################################
# Ÿ оδ. (ũ/ũƮ Ѵ.)
##########################################################################
sub read_data {
    require "./lib/cm_html_head.cgi";
	
    if($FORM{'p'}) {
        $gCurPage = $FORM{'p'};
    }
    else {
        $gCurPage = "1";
    }

    $gTotPage = int(($gNoOfData-1)/$gRecPerPage)+1;

    &html_head("bdr_link");

    print "<table border=0 width=$gTableWidth cellpadding=0 cellspacing=1 align=center valign=top nowrap>\n";
    print "<tr><td width=160 align=left valign=top>";
     
    &MenuButton;
    
    print "</td>\n\n";

    print "<td width=40>&nbsp;</td>\n";
    
    print "<td valign=top><br><br>\n\n";

    if(($gLinkType eq "0") || ($gLinkType eq "weblink")) {                      # 0 : ũ
       &readIndexFileForWebLink;
       print "</td></tr></table></td></tr><tr><td colspan=3>\n";
    }
    elsif(($gLinkType eq "1") || ($gLinkType eq "linklist")) {                   # 1 : ũƮ
       &readIndexFileForLinkList;
       print "</td></tr></table></td></tr><tr><td colspan=6>\n";
    }

    &go_prev_next_page;

    print "</td></tr></table>\n";
    	
    &html_foot;
}

##########################################################################
# ȭ鿡 ũ Ѵ
##########################################################################
sub readIndexFileForWebLink {
    local($i,$j,$rec_color,$txt_color,$actual_number,$short_subject,$short_date,$old_date,$new_date);
    local(@datum,@data_fn,@value_fn,@value);

    require "./lib/cm_get_date.cgi";
    &get_date;

    if(!-e "./members/logon/$COOKIE{'MEMBER_ID'}.cgi") {
       $gIsMember = false;	
    }
    else {
       $gIsMember = true;	
    }
    
    opendir(DIR, "./members/logon");
      @login_user = readdir(DIR);
    closedir(DIR);   
    $visiter_num = $#login_user - 1;


    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);

       print "<table border=0 width=100% cellspacing=0 cellpadding=0 valign=top>\n";    
       if($gIsMember eq "true") {
          print "<tr><td><font face=\"tahoma, arial\" size=1>Loged Members : <a href=javascript:NewWin('200','200','380','450','ShowMemberWin','bdr_member.cgi?action=show_logined_member')>$visiter_num</a></font></td><td align=right><a href=javascript:NewWin('200','200','510','580','ModifyWin','bdr_member.cgi?action=modify_form')><IMG SRC=$gIMG_Link/Info.gif border=0></a> <a href=bdr_login.cgi?db=$FORM{'db'}&action=logout_data2><IMG SRC=$gIMG_Link/logout.gif border=0></a></td></tr>\n";
       }
       else {
          print "<tr><td><font face=\"tahoma, arial\" size=1>Loged Members : <a href=javascript:NewWin('200','200','380','450','ShowMemberWin','bdr_member.cgi?action=show_logined_member')>$visiter_num</a></font></td><td align=right><a href=javascript:NewWin('200','200','510','580','RegisterWin','bdr_member.cgi')><IMG SRC=$gIMG_Link/register.gif border=0></a> <a href=bdr_link.cgi?db=$FORM{'db'}&action=login><IMG SRC=$gIMG_Link/login.gif border=0></a></td></tr>\n";
       }                         
       print "</table>\n";
       
    for($i=($gCurPage-1)*$gRecPerPage+1;$i<=($gCurPage-1)*$gRecPerPage+$gRecPerPage;$i++) {
        @data_fn = split(/\|/,$datum[$i]);       
        if(-e "$gBaseDIR/data/$data_fn[1].cgi") {
            open(HANDLE, "<$gBaseDIR/data/$data_fn[1].cgi");
              @value_fn = <HANDLE>;
            close(HANDLE);              	
         }
             
        @value = split(/\|/, $value_fn[0]);       

        $actual_number = ($gNoOfData+1)-$i;

        if($actual_number > 0) {
          $date_length = length($date);
          $short_date = substr($value[5],0,20);
          $value[6] =~ s/\|/&#124;/g;            
          $value[6] =~ s/(http:\/\/)([\&\w\+\-\/\=\?\.\~]+)/$url <img src=$gIMG_Link\/home.gif> <a href=\"$1$2\" target=\"_blank\">$1$2<\/a>/g;
          $value[6] =~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/$mail <img src=$gIMG_Link\/mail.gif> <a href=\"javascript:NewWin('200','200','300','309','MailWin,'bdr_mail.cgi?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$1')\">$1<\/a>/g;

       print "<table border=0 width=100% cellspacing=0 cellpadding=0 valign=top>\n";
           
       $c=$gTableBgcolor;
       $t=$gTableText;
       $tc=$gTableTapText;
       $dc=$gTableTapBgcolor;
       print "<tr><td>\n<table border=0 width=100% cellspacing=0 cellpadding=3>\n";
       print "<tr bgcolor=$dc><td>&nbsp;::&nbsp;<b><a href=\"$value[8]\" target=_blank><font color=$tc>$value[2]</font></a></b></td>\n";
       print "<td align=right><a href=bdr_link.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIMG_Link/modify.gif border=0 alt=\"Modify\"></a><a href=bdr_link.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIMG_Link/delete.gif border=0 alt=\"Delete\"></a>";
       print "</td></tr>\n";
       print "</table><table border=0 width=100% cellspacing=0 cellpadding=3>\n";
       
       # ȭ  (̹ ũǾֳ  ...)
       if($value[9] eq "") {
         print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\"><td colspan=2 align=left valign=top><font color=$t>$value[6]</font><br><br><br></td></tr>\n";
       }
       else {
         if($gBannerLocation eq "top") {
            print "<tr><td colspan=2 align=left valign=top><a href=\"$value[8]\" target=_blank><img src=\"$value[9]\" border=0></a></td></tr>\n";
            print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
            print "<td width=100% align=left valign=top colspan=2><font color=$t>$value[6]</font><br></td>\n";
            print "</tr>\n";  	  	  	
         }
         elsif($gBannerLocation eq "bottom") {
            print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
            print "<td width=100% align=left valign=top colspan=2><font color=$t>$value[6]</font><br></td>\n";
            print "</tr>\n";  	  	  	  	
            print "<tr><td colspan=2 align=left valign=top><a href=\"$value[8]\" target=_blank><img src=\"$value[9]\" border=0></a></td></tr>\n";     
         }
         elsif($gBannerLocation eq "left") {
            print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
            print "<td height=100 align=left valign=top width=100%><a href=\"$value[8]\" target=_blank><img src=\"$value[9]\" border=0 align=left></a><font color=$t>$value[6]</font></td>\n";     
            print "</tr>\n";  	  	
         }
         else {
            print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
            print "<td width=100% align=left valign=top colspan=2><a href=\"$value[8]\" target=_blank><img src=\"$value[9]\" border=0 align=right></a><font color=$t>$value[6]</font><br></td>\n";
            print "</tr>\n";  	
         }
       }
       
       if($gShowIPInfo eq "checked") {
          print "<tr><td colspan=2 height=5 align=right><font size=1 color=aaaaaa>$value[7]</font></td></tr>\n";
       }
       print "<tr><td colspan=2 background=\"$gIMG_Link/dot.gif\" width=100% height=3></td></tr>\n";
       print "<tr><td colspan=2>&nbsp;</td></tr>\n";
       print "</table>\n</td></tr>\n\n";
       }
    }
    unless($gNoOfData) {
        print "&nbsp;<table width=100% border=0 cellspacing=1 cellpadding=6 align=center>\n";
        print "<tr align=center><td><font color=\"red\"><b> ϵ Ʈ ϴ.</font></b></td></tr>\n";
    }
}

##########################################################################
# ȭ鿡 ũƮ Ѵ
##########################################################################
sub readIndexFileForLinkList {
    local($i,$j,$rec_color,$txt_color,$actual_number,$short_subject,$short_date,$old_date,$new_date);
    local(@datum,@data_fn,@value_fn,@value);

    require "./lib/cm_get_date.cgi";
    &get_date;

    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);

    if(!-e "./members/logon/$COOKIE{'MEMBER_ID'}.cgi") {
       $gIsMember = false;	
    }
    else {
       $gIsMember = true;	
    }

    opendir(DIR, "./members/logon");
      @login_user = readdir(DIR);
    closedir(DIR);   
    $visiter_num = $#login_user - 1;
	
    print "<table border=0  width=100% cellspacing=0 cellpadding=0 valign=top nowrap>\n";
    if($gIsMember eq "true") {
       print "<tr><td><font face=\"tahoma, arial\" size=1>Loged Members : <a href=javascript:NewWin('200','200','380','450','ShowMemberWin','bdr_member.cgi?action=show_logined_member')>$visiter_num</a></font></td><td align=right><a href=javascript:NewWin('200','200','510','580','ModifyWin','bdr_member.cgi?action=modify_form')><IMG SRC=$gIMG_Link/Info.gif border=0></a> <a href=bdr_login.cgi?db=$FORM{'db'}&action=logout_data2><IMG SRC=$gIMG_Link/logout.gif border=0></a></div></td></tr>\n";
    }
    else {
       print "<tr><td><font face=\"tahoma, arial\" size=1>Loged Members : <a href=javascript:NewWin('200','200','380','450','ShowMemberWin','bdr_member.cgi?action=show_logined_member')>$visiter_num</a></font></td><td align=right><a href=javascript:NewWin('200','200','510','580','RegisterWin','bdr_member.cgi')><IMG SRC=$gIMG_Link/register.gif border=0></a> <a href=bdr_link.cgi?db=$FORM{'db'}&action=login><IMG SRC=$gIMG_Link/login.gif border=0></a></div></td></tr>\n";
    }                      
    $c=$gTableBgcolor;
    $t=$gTableText;
    print "<tr><td colspan=2><table border=0 cellspacing=0 cellpadding=0 nowrap>\n";
    print "<tr bgcolor=$gTableTapBgcolor height=20>\n";
    print "<td align=left width=100>&nbsp;&nbsp;<font color=\"$gTableTapText\"> </font></td><td align=left width=140>&nbsp;&nbsp;<font color=\"$gTableTapText\">&nbsp;&nbsp;ó</font></td>\n";
    print "<td align=left width=250>&nbsp;&nbsp;<font color=\"$gTableTapText\">E-Mail</font></td><td align=left width=340>&nbsp;&nbsp;&nbsp;&nbsp;<font color=\"$gTableTapText\">Http/Ftp/Telenet</font></td>\n";
    print "<td width=14>&nbsp;&nbsp;</td><td width=14>&nbsp;&nbsp;</td></tr>\n\n";
	
    for($i=($gCurPage-1)*$gRecPerPage+1;$i<=($gCurPage-1)*$gRecPerPage+$gRecPerPage;$i++) {
        @data_fn = split(/\|/,$datum[$i]);       
        if(-e "$gBaseDIR/data/$data_fn[1].cgi") {
            open(HANDLE, "<$gBaseDIR/data/$data_fn[1].cgi");
              @value_fn = <HANDLE>;
            close(HANDLE);              	
         }
             
        @value = split(/\|/, $value_fn[0]);       

        $actual_number = ($gNoOfData+1)-$i;

        if($actual_number > 0) {
	   $date_length = length($value[5]);
      	   $short_date = substr($value[5],0,20);

           if($value[6] eq "") { 
	     print "<tr><td colspan=6>\n";
	     print "<table border=0 cellspacing=0 cellpadding=1 nowrap>\n";
	     print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
                     print "<td align=left width=100>$value[2]</td>\n";
   	     print "<td align=left width=140>$value[3]</td>\n";
             	     if($COOKIE{'MEMBER_NAME'}) {    # ȸα Ǿ ȸ  
                        print "<td align=left width=250><a href=\"javascript:NewWin('200','200','300','309','MailWin','bdr_mail.cgi?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$value[4]')\">$value[4]</a></td>\n";
                     }
                     else {
                        print "<td align=left width=250><a href=\"javascript:NewWin('200','200','300','309','MailWin','bdr_mail.cgi?tomail=$value[4]')\">$value[4]</a></td>\n";
                     }   	     
	     print "<td align=left width=340><a href=\"$value[8]\" target=_blank>$value[8]</a></td>\n";
	     print "<td align=center width=14><a href=bdr_link.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIMG_Link/mod.gif border=0 alt=\"Modify\"></a></td>\n";
	     print "<td align=center width=14><a href=bdr_link.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIMG_Link/del.gif border=0 alt=\"Delete\"></a></td>\n";
	     print "</tr>\n";
	   }
	   else {
	     print "<tr><td colspan=6>\n";
	     print " <table border=0 cellspacing=0 cellpadding=1 nowrap>\n";
	     print "  <tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
                     print "   <td align=left width=100 onmouseover=\"drc('$value[6]<br><br>'); high(popup);\" onmouseout=\"low(popup);\">$value[2]</td>\n";
   	     print "   <td align=left width=140 onmouseover=\"drc('$value[6]<br><br>'); high(popup);\" onmouseout=\"low(popup);\">$value[3]</td>\n";
             	     if($COOKIE{'MEMBER_NAME'}) {    # ȸα Ǿ ȸ  
                        print "   <td align=left width=250 onmouseover=\"drc('$value[6]<br><br>'); high(popup);\" onmouseout=\"low(popup);\"><a href=\"javascript:NewWin('200','200','300','309','MailWin','bdr_mail.cgi?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$value[4]')\">$value[4]</a></td>\n";
                     }
                     else {
                        print "   <td align=left width=250 onmouseover=\"drc('$value[6]<br><br>'); high(popup);\" onmouseout=\"low(popup);\"><a href=\"javascript:NewWin('200','200','300','309','MailWin','bdr_mail.cgi?tomail=$value[4]')\">$value[4]</a></td>\n";
                     }                           	     
	     print "   <td align=left width=340 onmouseover=\"drc('$value[6]<br><br>'); high(popup);\" onmouseout=\"low(popup);\"><a href=\"$value[8]\" target=_blank>$value[8]</a></td>\n";
	     print "   <td align=center width=14><a href=bdr_link.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIMG_Link/mod.gif border=0 alt=\"Modify\"></a></td>\n";
	     print "   <td align=center width=14><a href=bdr_link.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIMG_Link/del.gif border=0 alt=\"Delete\"></a></td>\n";
	     print "  </tr>\n";	   	
	   }
           print "  <tr><td colspan=6 background=\"$gIMG_Link/dot.gif\" width=100% height=3></td></tr>\n";
           print " </table>\n";
           print "</td></tr>\n\n";
        }
    }
   
    unless($gNoOfData) {
       print "&nbsp;<table width=100% border=0 cellspacing=1 cellpadding=6 align=center>\n";
       print "<tr align=center><td><font color=\"red\"><b>No List</font></b></td></tr>\n";
    }
    print "</table>\n";
}

##########################################################################
#  
##########################################################################
sub go_prev_next_page {
       print "<table border=0 cellpadding=9 cellspacing=1 align=center valign=middle height=100><tr><td align=center>\n";
       $term = $gListNumber;
       $f = 1;
       $l = $term;
       while ($f <= $gTotPage) {
         if(($f <= $gCurPage) && ($gCurPage <= $l)) {
          $prevp = $f - 1;

          if ($prevp > 0) {
             print "<a href=bdr_link.cgi?db=$FORM{'db'}&action=r&p=$prevp><img src=$gIMG_Link/y_prev.gif border=0 alt=\" \"></a>..";
          }
          
          if ($l <= $gTotPage) {
	for ($page = $f; $page <= $l; $page++) {
	      if ($page == $gCurPage) {
                         print "<font color=$gTableText>[<font color=blue><b>$page</b></font>]</font>";
	      }
                      else {
                         print "<a href=bdr_link.cgi?db=$FORM{'db'}&action=r&p=$page>[$page]</a>";
                      }
               }
          }
          else {
             for ($page = $f; $page <= $gTotPage; $page++) {
	   if ($page == $gCurPage) {
                     print "<font color=$gTableText>[<font color=blue><b>$page</b></font>]</font>";
                   }
                   else {
                     print "<font color=$gTextColor><a href=bdr_link.cgi?db=$FORM{'db'}&action=r&p=$page>[$page]</font></a>";
                   }
            }
         }
         $nextp = $l + 1;
         
         if ($nextp <= $gTotPage) {
           print "..<a href=bdr_link.cgi?db=$FORM{'db'}&action=r&p=$nextp><img src=$gIMG_Link/y_next.gif border=0 alt=\" \"></a>";
         }
     }
     
     $f = $f + $term;
     $l = $l + $term;
   }
   print "</td></tr></table>\n";
}

##########################################################################
# ȭ  ⸦ Ѵ
##########################################################################
sub MenuButton {
    &getItemCounter;
    
    print "<br><br><table width=160 border=0 cellspacing=1 cellpadding=2 align=center>\n";
    print "<tr>\n";
    print "<td align=left>\n";
    print "<table border=0 cellspacing=1 cellpadding=2 width=160 valign=top>\n";    
    print "<tr><td background=$gIMG_Link/tb_top.gif height=30 width=160>\n";    
    # ŸƲ ǥÿ
    if($gTitleUse eq "checked") {
         print "<center><b>$gTitleText</b></center>\n";
    }    
    print "</td></tr>\n";
    
    if ($gItem > 0) {   # 1    	
        print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=bdr_link.cgi?db=$FORM{'db'}&action=search&word=Item1>$gItem1</a> ($icounter1)</td></tr>\n";
        print "<tr><td width=80% height=1 bgcolor=#e3e3e3></td></tr>\n";             
    }

    if (int($gItem) > 1) {   # 2
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=bdr_link.cgi?db=$FORM{'db'}&action=search&word=Item2>$gItem2</a> ($icounter2)</td></tr>\n";
       print "<tr><td width=80% height=1 bgcolor=#e3e3e3></td></tr>\n";       
    }

    if (int($gItem) > 2) {   # 3
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=bdr_link.cgi?db=$FORM{'db'}&action=search&word=Item3>$gItem3</a> ($icounter3)</td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";
    }

    if (int($gItem) > 3) {   # 4
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=bdr_link.cgi?db=$FORM{'db'}&action=search&word=Item4>$gItem4</a> ($icounter4)</td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";       
    }

    if (int($gItem) > 4) {   # 5
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=bdr_link.cgi?db=$FORM{'db'}&action=search&word=Item5>$gItem5</a> ($icounter5)</td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";       
    }

    if (int($gItem) > 5) {   # 6
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=bdr_link.cgi?db=$FORM{'db'}&action=search&word=Item6>$gItem6</a> ($icounter6)</td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";              
    }
    
    if (int($gItem) > 6) {   # 7
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=bdr_link.cgi?db=$FORM{'db'}&action=search&word=Item7>$gItem7</a> ($icounter7)</td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";                            
    }

    if (int($gItem) > 7) {   # 8
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=bdr_link.cgi?db=$FORM{'db'}&action=search&word=Item8>$gItem8</a> ($icounter8)</td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";                                   
    }
                
    #   or    , ü ,  
      if($gUserUp eq "checked") {
        print "<tr><td background=$gIMG_Link/tb_bottom.gif height=30 width=200 align=center>\n";
        print "<a href=bdr_link.cgi?db=$FORM{'db'}&action=show_user_input_form><img src=$gIMG_Link/write.gif border=0 alt=\"Register\"></a>\n";
        print "<a href=bdr_link.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}><img src=$gIMG_Link/total_list.gif border=0 alt=\"Total List\"></a>\n";
        print "&nbsp;<a href=bdr_link.cgi?db=$FORM{'db'}&action=admin_login&p=$gCurPage&c=show_config_form><img src=$gIMG_Link/admin.gif border=0 alt=\"Administrator Only\"></a>\n";
        print "</td></tr>\n";
        print "</table></font>\n";
      }
      else {
        print "<tr><td background=$gIMG_Link/tb_bottom.gif height=30 width=200 align=center>\n";
        print "<a href=bdr_link.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}><img src=$gIMG_Link/total_list.gif border=0 alt=\"Total List\"></a>\n";
        print "&nbsp;<a href=bdr_link.cgi?db=$FORM{'db'}&action=admin_login&p=$gCurPage&c=show_config_form><img src=$gIMG_Link/admin.gif border=0 alt=\"Administrator Only\"></a>\n";
        print "</td></tr>\n";
        print "</table></font>\n";
      }
          
    print "</td></tr></table>\n";
}

##########################################################################
# ⿡  ũ Ѵ
##########################################################################
sub search_data_for_WebLink {
    require "./lib/cm_get_num_info.cgi"; 
    require "./lib/cm_html_head.cgi";
    	
    local($data,$counter);
    local(@datum,@value,@data_fn,@value_fn);    
    
    if(!-e "./members/logon/$COOKIE{'MEMBER_ID'}.cgi") {
       $gIsMember = false;	
    }
    else {
       $gIsMember = true;	
    }
    
    &get_num_info;  
    &html_head("bdr_link");
    unless($FORM{'word'}) {
            print "<br><br><hr noshade width=80%>\n";
            print "<font color=blue>˻ Է ʾҽϴ</font>\n";
            print "<hr noshade width=80%>\n";
            print "<p><center><a href=bdr_link.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>ư</font></a></center>\n";
    }
    else {
        open(HANDLE,"$gBaseDIR/$gDatFile");
            @datum = <HANDLE>;
        close(HANDLE);
        
          print "<table border=0 width=$gTableWidth cellpadding=0 cellspacing=1 align=center valign=top>\n";
          print "<tr><td width=160 align=left valign=top>";
     
          &MenuButton;
    
          print "</td>\n\n";   
          
          print "<td width=40>&nbsp;</td>\n\n";   
          
          print "<td align=left valign=top>\n<table border=0 width=100% cellspacing=0 cellpadding=0>\n";
 
# ũ ̸           
         print "<tr><td height=27 valign=bottom>\n";
         print "<table border=0 width=100%><tr><td align=left><br>\n";

         if ($FORM{'word'} eq "Item1") {
            print "&nbsp;<b>:: $gItem1 ::</b>\n";
         }
         if ($FORM{'word'} eq "Item2") {
            print "&nbsp;<b>:: $gItem2 ::</b>\n";
         }
         if ($FORM{'word'} eq "Item3") {
            print "&nbsp;<b>:: $gItem3 ::</b>\n";
         }
         if ($FORM{'word'} eq "Item4") {
            print "&nbsp;<b>:: $gItem4 ::</b>\n";
         }
         if ($FORM{'word'} eq "Item5") {
            print "&nbsp;<b>:: $gItem5 ::</b>\n";
         }      
         if ($FORM{'word'} eq "Item6") {
            print "&nbsp;<b>:: $gItem6 ::</b>\n";
         }      
         if ($FORM{'word'} eq "Item7") {
            print "&nbsp;<b>:: $gItem7 ::</b>\n";
         }      
         if ($FORM{'word'} eq "Item8") {
            print "&nbsp;<b>:: $gItem8 ::</b>\n";
         }                                 
         print "</td><td align=right valign=bottom><br>";
         if($gIsMember eq "true") {
           print "<a href=javascript:NewWin('200','200','510','580','ModifyWin','bdr_member.cgi?action=modify_form')><IMG SRC=$gIMG_Link/Info.gif border=0></a> <a href=bdr_login.cgi?db=$FORM{'db'}&action=logout_data2><IMG SRC=$gIMG_Link/logout.gif border=0></a>\n";
         }
         else {
           print "<a href=javascript:NewWin('200','200','510','580','RegisterWin','bdr_member.cgi')><IMG SRC=$gIMG_Link/register.gif border=0></a> <a href=bdr_link.cgi?db=$FORM{'db'}&action=login><IMG SRC=$gIMG_Link/login.gif border=0></a>\n";
         }                                             
         print "</td></tr></table>";
         print "</td></tr>\n";
              
        $counter = 0; 
        for($i=1;$i<=$gNoOfData;$i++ ) {
           @data_fn = split(/\|/,$datum[$i]);        	       
           if(-e "$gBaseDIR/data/$data_fn[1].cgi") {
              open(HANDLE, "<$gBaseDIR/data/$data_fn[1].cgi");
                @value_fn = <HANDLE>;
              close(HANDLE);              	
           }
             
          @value = split(/\|/, $value_fn[0]);   
		  if($value[10] =~ /$FORM{'word'}/i) {

                &printRecordForWebLink;

                $counter++;
            }
         } 
         print "</td></tr></table></td></tr><tr><td colspan=3>\n";         
         print "</td></tr></table>\n";
    }
    print "<br><br><br><center><a href=bdr_link.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>ư</font></a></center><br><br>\n";

    &html_foot;  
}

##########################################################################
# ⿡  ũƮ Ѵ
##########################################################################
sub search_data_for_LinkList {
    require "./lib/cm_get_num_info.cgi"; 
    require "./lib/cm_html_head.cgi";
    
    local($data,$counter);
    local(@datum,@value,@data_fn,@value_fn);    
    
    if(!-e "./members/logon/$COOKIE{'MEMBER_ID'}.cgi") {
       $gIsMember = false;	
    }
    else {
       $gIsMember = true;	
    }
    
    &get_num_info;  
    &html_head("bdr_link");
    unless($FORM{'word'}) {
            print "<br><br><hr noshade width=80%>\n";
            print "<font color=blue>˻ Է ʾҽϴ</font>\n";
            print "<hr noshade width=80%>\n";
            print "<p><center><a href=bdr_link.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>ư</font></a></center>\n";
    }
    else {
        open(HANDLE,"$gBaseDIR/$gDatFile");
            @datum = <HANDLE>;
        close(HANDLE);
        print "<table border=0 width=$gTableWidth cellpadding=0 cellspacing=1 align=center valign=top nowrap>\n";
        print "<tr><td width=160 align=left valign=top>";
     
        &MenuButton;
    
        print "</td>\n\n";   
          
        print "<td width=40>&nbsp;</td>\n";
        
        print "<td align=left valign=top><br>\n";

# ũ ̸           
         print "<table border=0 width=100%><tr><td align=left>\n";
         
         if ($FORM{'word'} eq "Item1") {
            print "&nbsp;<b>:: $gItem1 ::</b>\n";
         }
         if ($FORM{'word'} eq "Item2") {
            print "&nbsp;<b>:: $gItem2 ::</b>\n";
         }
         if ($FORM{'word'} eq "Item3") {
            print "&nbsp;<b>:: $gItem3 ::</b>\n";
         }
         if ($FORM{'word'} eq "Item4") {
            print "&nbsp;<b>:: $gItem4 ::</b>\n";
         }
         if ($FORM{'word'} eq "Item5") {
            print "&nbsp;<b>:: $gItem5 ::</b>\n";
         }
         if ($FORM{'word'} eq "Item6") {
            print "&nbsp;<b>:: $gItem6 ::</b>\n";
         }
         if ($FORM{'word'} eq "Item7") {
            print "&nbsp;<b>:: $gItem7 ::</b>\n";
         }
         if ($FORM{'word'} eq "Item8") {
            print "&nbsp;<b>:: $gItem8 ::</b>\n";
         }                           
         print "</td><td align=right valign=bottom>";
         if($gIsMember eq "true") {
           print "<a href=javascript:NewWin('200','200','510','580','ModifyWin','bdr_member.cgi?action=modify_form')><IMG SRC=$gIMG_Link/Info.gif border=0></a> <a href=bdr_login.cgi?db=$FORM{'db'}&action=logout_data2><IMG SRC=$gIMG_Link/logout.gif border=0></a>\n";
         }
         else {
           print "<a href=javascript:NewWin('200','200','510','580','RegisterWin','bdr_member.cgi')><IMG SRC=$gIMG_Link/register.gif border=0></a> <a href=bdr_link.cgi?db=$FORM{'db'}&action=login><IMG SRC=$gIMG_Link/login.gif border=0></a>\n";
         }                  
        print "</td></tr></table>";
        print "<table border=0 cellspacing=0 cellpadding=0 nowrap>\n";
        print "<tr bgcolor=$gTableTapBgcolor height=20>\n";
        print "<td align=left width=100>&nbsp;&nbsp;<font color=\"$gTableTapText\"> </font></td><td align=left width=140>&nbsp;&nbsp;<font color=\"$gTableTapText\">&nbsp;&nbsp;ó</font></td>\n";
        print "<td align=left width=250>&nbsp;&nbsp;<font color=\"$gTableTapText\">E-Mail</font></td><td align=left width=340>&nbsp;&nbsp;&nbsp;&nbsp;<font color=\"$gTableTapText\">Http/Ftp/Telenet</font></td>\n";
        print "<td width=14>&nbsp;&nbsp;</td><td width=14>&nbsp;&nbsp;</td></tr>\n";
             
        $counter = 0; 
        for($i=1;$i<=$gNoOfData;$i++ ) {
           @data_fn = split(/\|/,$datum[$i]);        	       
           if(-e "$gBaseDIR/data/$data_fn[1].cgi") {
              open(HANDLE, "<$gBaseDIR/data/$data_fn[1].cgi");
                @value_fn = <HANDLE>;
              close(HANDLE);              	
           }
             
          @value = split(/\|/, $value_fn[0]);               
            if($value[10] =~ /$FORM{'word'}/i) {

                &printRecordForLinkList;
                $counter++;
            }
         } 
       unless($gNoOfData) {
         print "&nbsp;<table width=100% border=0 cellspacing=1 cellpadding=6 align=center>\n";
         print "<tr align=center><td><font color=\"red\"><b>No List</font></b></td></tr>\n";
       }
       print "</table>\n";
    }
     print "<br><br><br><center><a href=bdr_link.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>ư</font></a><br><br></center>\n";

     &html_foot;  
}

##########################################################################
# ⿡  ũ ȭ鿡 Ѵ
##########################################################################
sub printRecordForWebLink {
    local($short_subject,$short_date,$actual_number,$old_date,$new_date);

    $date_length = length($value[5]);
    $short_date = substr($value[5],0,20);

    print "<tr><td><table border=0 cellspacing=0 cellpadding=3 width=100%>";
    $c=$gTableBgcolor;
    $t=$gTableText;
    $tc=$gTableTapText;
    $dc=$gTableTapBgcolor;
    $value[6] =~ s/\|/&#124;/g;            
    $value[6] =~ s/(http:\/\/)([\&\w\+\-\/\=\?\.\~]+)/$url <img src=$gIMG_Link\/home.gif> <a href=\"$1$2\" target=\"_blank\">$1$2<\/a>/g;
    $value[6] =~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/$mail <img src=$gIMG_Link\/mail.gif> <a href=\"javascript:NewWin('200','200','300','309','MailWin','bdr_mail.cgi?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$1')\">$1<\/a>/g;
    print "<tr bgcolor=$dc><td>&nbsp;::&nbsp;<b><a href=\"$value[8]\" target=_blank><font color=$tc>$value[2]</font></a></b></td>";
    print "<td align=right><a href=bdr_link.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIMG_Link/modify.gif border=0 alt=\"Modify\"></a><a href=bdr_link.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIMG_Link/delete.gif border=0 alt=\"Delete\"></a>\n";
    print "</td></tr>\n";
    print "</table><table border=0 width=100% cellspacing=0 cellpadding=3>\n";

    # ȭ  (̹ ũǾֳ  ...)
    if($value[9] eq "") {
        print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\"><td colspan=2 align=left valign=top><font color=$t>$value[6]</font><br><br><br></td></tr>\n";
    }
    else {
      if($gBannerLocation eq "top") {
         print "<tr><td colspan=2 align=left valign=top><a href=\"$value[8]\" target=_blank><img src=\"$value[9]\" border=0></a></td></tr>\n";
         print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
         print "<td width=100% align=left valign=top colspan=2><font color=$t>$value[6]</font><br></td>\n";
         print "</tr>\n";  	  	  	
      }
      elsif($gBannerLocation eq "bottom") {
         print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
         print "<td width=100% align=left valign=top colspan=2><font color=$t>$value[6]</font><br></td>\n";
         print "</tr>\n";  	  	  	  	
         print "<tr><td colspan=2 align=left valign=top><a href=\"$value[8]\" target=_blank><img src=\"$value[9]\" border=0></a></td></tr>\n";     
      }
      elsif($gBannerLocation eq "left") {
         print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
         print "<td height=100 align=left valign=top width=100%><a href=\"$value[8]\" target=_blank><img src=\"$value[9]\" border=0 align=left></a><font color=$t>$value[6]</font></td>\n";
         print "</tr>\n";  	
      }
      else {
         print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
         print "<td width=100% align=left valign=top colspan=2><a href=\"$value[8]\" target=_blank><img src=\"$value[9]\" border=0 align=right></a><font color=$t>$value[6]</font><br></td>\n";
         print "</tr>\n";  	
      }
    }
    
    if($gShowIPInfo eq "checked") {
       print "<tr><td colspan=2 height=5 align=right><font size=1 color=aaaaaa>$value[7]</font></td></tr>\n";
    }
    print "<tr><td colspan=2 background=\"$gIMG_Link/dot.gif\" width=100% height=3></td></tr>\n";
    print "<tr><td colspan=2>&nbsp;</td></tr>\n";
    print "</table></tr>\n\n";
}

##########################################################################
# ⿡  ũƮ ȭ鿡 Ѵ
##########################################################################
sub printRecordForLinkList {
    local($short_subject,$short_date,$actual_number,$old_date,$new_date);

    $date_length = length($value[5]);    
    $short_date = substr($value[5],0,20);

    $c=$gTableBgcolor;
    $t=$gTableText;         

 
    # ȭ 
    if($value[6] eq "") {    
      print "<tr><td colspan=6>\n";
      print "<table border=0 cellspacing=0 cellpadding=1 nowrap>\n";
      print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
      print "<td align=left width=100>$value[2]</td>\n";        # ̸
      print "<td align=left width=140>$value[3]</td>\n";        # ó
      if($COOKIE{'MEMBER_NAME'}) {    # ȸα Ǿ ȸ  
         print "<td align=left width=250><a href=\"javascript:NewWin('200','200','300','309','MailWin','bdr_mail.cgi?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$value[4]')\">$value[4]</a></td>\n";     # E-Mail
      }
      else {
         print "<td align=left width=250><a href=\"javascript:NewWin('200','200','300','309','MailWin','bdr_mail.cgi?tomail=$value[4]')\">$value[4]</a></td>\n";     # E-Mail
      }      
      print "<td align=left width=340><a href=\"$value[8]\"  target=\"_blank\">$value[8]</a></td>\n";
      print "<td align=center width=14><a href=bdr_link.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIMG_Link/mod.gif border=0 alt=\"Modify\"></a></td>\n";
      print "<td align=center width=14><a href=bdr_link.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIMG_Link/del.gif border=0 alt=\"Delete\"></a></td>\n";
      print "</tr>\n";
    }
    else {
      print "<tr><td colspan=6>\n";
      print "<table border=0 cellspacing=0 cellpadding=1 nowrap>\n";
      print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
      print "<td align=left width=100 onmouseover=\"drc('$value[6]<br><br>'); high(popup);\" onmouseout=\"low(popup);\">$value[2]</td>\n";        # ̸
      print "<td align=left width=140 onmouseover=\"drc('$value[6]<br><br>'); high(popup);\" onmouseout=\"low(popup);\">$value[3]</td>\n";        # ó
      if($COOKIE{'MEMBER_NAME'}) {    # ȸα Ǿ ȸ  
         print "<td align=left width=250 onmouseover=\"drc('$value[6]<br><br>'); high(popup);\" onmouseout=\"low(popup);\"><a href=\"javascript:NewWin('200','200','300','309','MailWin','bdr_mail.cgi?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$value[4]')\">$value[4]</a></td>\n";      # E-Mail
      }
      else {
         print "<td align=left width=250 onmouseover=\"drc('$value[6]<br><br>'); high(popup);\" onmouseout=\"low(popup);\"><a href=\"javascript:NewWin('200','200','300','309','MailWin','bdr_mail.cgi?tomail=$value[4]')\">$value[4]</a></td>\n";      # E-Mail
      }           
      print "<td align=left width=340 onmouseover=\"drc('$value[6]<br><br>'); high(popup);\" onmouseout=\"low(popup);\"><a href=\"$value[8]\" target=_blank>$value[8]</a></td>\n";
      print "<td align=center width=14><a href=bdr_link.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIMG_Link/mod.gif border=0 alt=\"Modify\"></a></td>\n";
      print "<td align=center width=14><a href=bdr_link.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIMG_Link/del.gif border=0 alt=\"Delete\"></a></td>\n";
      print "</tr>\n";    		    
    }

    print "<tr><td colspan=6 background=\"$gIMG_Link/dot.gif\" width=100% height=3></td></tr>\n";
    print "</table></td></tr>\n";
}


##########################################################################
# Item ī;
##########################################################################
sub getItemCounter {
    require "./lib/cm_get_num_info.cgi";   
    	
    local($data,$counter);
    local(@datum,@value,@data_fn,@value_fn);    

    &get_num_info;  

    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
          
    $icounter1 = 0; 
    $icounter2 = 0; 
    $icounter3 = 0; 
    $icounter4 = 0; 
    $icounter5 = 0;         
    $icounter6 = 0;         
    $icounter7 = 0;         
    $icounter8 = 0;         
    
    for($i=1;$i<=$gNoOfData;$i++ ) {
       @data_fn = split(/\|/,$datum[$i]);        	       
       if(-e "$gBaseDIR/data/$data_fn[1].cgi") {
          open(HANDLE, "<$gBaseDIR/data/$data_fn[1].cgi");
            @value_fn = <HANDLE>;
          close(HANDLE);              	
       }
         
       @value = split(/\|/, $value_fn[0]);  

        if($value[10] =~ /item1/i) {
            $icounter1++;
        }
        elsif($value[10] =~ /item2/i) {
            $icounter2++;
        }
        elsif($value[10] =~ /item3/i) {
            $icounter3++;
        }
        elsif($value[10] =~ /item4/i) {
            $icounter4++;
        }
        elsif($value[10] =~ /item5/i) {
            $icounter5++;
        }
        elsif($value[10] =~ /item6/i) {
            $icounter6++;
        }
        elsif($value[10] =~ /item7/i) {
            $icounter7++;
        }
        elsif($value[10] =~ /item8/i) {
            $icounter8++;
        }                                    
    } 
}

##########################################################################
#  ۾ 
##########################################################################
sub show_admin_input_form {
    require "./lib/cm_html_head.cgi";
    require "./lib/cm_get_date.cgi";
    require "./lib/cm_get_cookie.cgi";    
    
    local($data,$subject,$content,$name,$value);
    local(@value,@cookies);
    
    &get_date; 
    &get_cookie;
    &html_head("bdr_link");
    print "<form method=post name=AdminInputForm action=bdr_link.cgi>\n";    
    print "<br><table border=1 width=450 bgcolor=#eeeeee bordercolorlight=#cccccc bordercolordark=#ffffff cellspacing=0 cellpadding=5 align=center>\n";
    print "<tr><td align=center>\n";

    print "<table border=0 cellspacing=1 cellpadding=2>\n";    
    print "<input type=hidden name=db value=$FORM{'db'}>\n";
    print "<input type=hidden name=action value=write>\n";
    print "<input type=hidden name=p value=1>\n";

    if(int($gItem)>0) {
       print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td>
          <select name=Items style=\"background-color:#ffffff;border:1 solid black\">";

       print "<option value=Item1 selected>$gItem1" if(int($gItem)>0);
       print "<option value=Item2>$gItem2" if(int($gItem)>1);
       print "<option value=Item3>$gItem3" if(int($gItem)>2);
       print "<option value=Item4>$gItem4" if(int($gItem)>3);
       print "<option value=Item5>$gItem5" if(int($gItem)>4);
       print "<option value=Item6>$gItem6" if(int($gItem)>5);
       print "<option value=Item7>$gItem7" if(int($gItem)>6);
       print "<option value=Item8>$gItem8" if(int($gItem)>7);    
       print "</select>\n";
       print "</td></tr>\n";
    }
                              
       # ũŸԿ  Է ޶
       if(($gLinkType eq "0") || ($gLinkType eq "weblink")){
          print "<tr><td align=right><span class=cls><b>Homepage</b></span></td>\n";
          print "<td><input name=homepage type=text value='http://' size=53 class=text></td></tr>\n";
          print "<input type=hidden name=phone value=\"$value[3]\">\n";                             # Ӽ : ó
          print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td>\n";
          print "<td><input name=email value='' type=text size=53 class=text></td></tr>\n";        
          print "<tr><td align=right><span class=cls><b>Subject</b></span></td>\n";
          print "<td><input name=subject value='' type=text size=53 value='' class=text>\n";
          print "<input type=hidden name=html value=checked checked></td></tr>\n";
          print "<tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=15 cols=53 class=comment></textarea></td></tr>\n";
          print "<tr><td align=right><span class=cls><b>Banner URL</b></span></td>\n";
          print "<td><input name=banner value='' type=text size=53 class=text>\n";
          print "</td></tr>\n";
          print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
          print "</tr></table>\n";
          print "</td></tr></table>\n";
          print "</form>\n";
          print "<script language=\"javascript\">document.AdminInputForm.homepage.focus();</script>\n";          
       }
       elsif(($gLinkType eq "1") || ($gLinkType eq "linklist")) {
          print "<tr><td align=right><span class=cls><b>Name</b></span></td>\n";
          print "<td><input name=subject value='' type=text size=53 value='' class=text>\n";
          print "<input type=hidden name=banner value=\"$value[9]\">\n";                             # Ӽ : 
          print "</td></tr>\n";    
          print "<tr><td align=right><span class=cls><b>Phone</b></span></td>\n";
          print "<td><input name=phone value='' type=text size=53 class=text></td></tr>\n";    
          print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td>\n";
          print "<td><input name=email value='' type=text size=53 class=text></td></tr>\n";        
          print "<tr><td align=right><span class=cls><b>Homepage</b></span></td>\n";
          print "<td><input name=homepage type=text value='http://' size=53 class=text></td></tr>\n";
          print "<input type=hidden name=html value=checked checked><tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=15 cols=53 class=comment></textarea></td></tr>\n";
          print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
          print "</tr></table>\n";
          print "</td></tr></table>\n";
          print "</form>\n";
          print "<script language=\"javascript\">document.AdminInputForm.subject.focus();</script>\n";
       }           
       
    &html_foot;
}

##########################################################################
#  ۾ 
##########################################################################
sub show_user_input_form {
    require "./lib/cm_html_head.cgi";
    require "./lib/cm_get_date.cgi";
    require "./lib/cm_get_cookie.cgi";    
    
    local($data,$subject,$content,$name,$value);
    local(@value,@cookies);
    
    &get_date; 
    &get_cookie;
    &html_head("bdr_link");
    print "
           <form method=post name=inputForm action=bdr_link.cgi>               
           <br><table border=1 width=450 bgcolor=#eeeeee bordercolorlight=#cccccc bordercolordark=#ffffff cellspacing=0 cellpadding=5 align=center>
           <tr><td align=center>   
           
           <table border=0 cellspacing=1 cellpadding=2 align=center>
           <input type=hidden name=db value=$FORM{'db'}>
           <input type=hidden name=action value=write>
           <input type=hidden name=p value=1>";

    if(int($gItem)>0) {
       print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td>
           <select name=Items style=\"background-color:#ffffff;border:1 solid black\">\n";
             
       print "<option value=Item1 selected>$gItem1" if(int($gItem)>0);
       print "<option value=Item2>$gItem2" if(int($gItem)>1);
       print "<option value=Item3>$gItem3" if(int($gItem)>2);
       print "<option value=Item4>$gItem4" if(int($gItem)>3);
       print "<option value=Item5>$gItem5" if(int($gItem)>4);
       print "<option value=Item6>$gItem6" if(int($gItem)>5);
       print "<option value=Item7>$gItem7" if(int($gItem)>6);
       print "<option value=Item8>$gItem8" if(int($gItem)>7);
       print "
           </select>
           </td></tr>\n";
    } 
                           
     # ũŸԿ  Է ޶
    if(($gLinkType eq "0") || ($gLinkType eq "weblink")) {
       print "<tr><td align=right><span class=cls><b>Password</b></span></td>\n";
       print "<td><input type=password name=passwd size=53 maxlength=16 class=text></td></tr>\n";
       print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
       print "<input name=homepage type=text value='http://' size=53 class=text>\n";
       print "<input type=hidden name=phone value=\"$value[3]\">\n";                             # Ӽ : ó
       print "</td></tr>\n";         
       print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
       print "<input name=email value='' type=text size=53 class=text></td></tr>\n";                 
       print "<tr><td align=right><span class=cls><b>Subject</b></span></td><td>\n";
       print "<input name=subject value='' type=text size=53 value='' class=text>\n";
       print "<input type=hidden name=html value=checked checked></td></tr>\n";
       print "<tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=15 cols=53 class=comment></textarea></td></tr>\n";
       print "<tr><td align=right><span class=cls><b>Banner URL</b></span></td><td>\n";
       print "<input name=banner value='' type=text size=53 class=text></td></tr>\n";
       print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
       print "</tr></table>\n";
       print "</td></tr></table>\n";
       print "</form>\n";          	
    }
    elsif(($gLinkType eq "1") || ($gLinkType eq "linklist")){
       print "<tr><td align=right><span class=cls><b>Password</b></span></td>\n";
       print "<td><input type=password name=passwd size=53 maxlength=16 class=text></td></tr>\n";
       print "<tr><td align=right><span class=cls><b>Name</b></span></td><td>\n";
       print "<input name=subject value='' type=text size=53 value='' class=text>\n";
       print "<input type=hidden name=banner value=\"$value[9]\">\n";                             # Ӽ :          
       print "</td></tr>\n";    
       print "<tr><td align=right><span class=cls><b>Phone</b></span></td><td>\n";
       print "<input name=phone value='' type=text size=53 class=text></td></tr>\n";        
       print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
       print "<input name=email value='' type=text size=53 class=text></td></tr>\n";                
       print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
       print "<input name=homepage type=text value='http://' size=53 class=text></td></tr>\n";
       print "<input type=hidden name=html value=checked checked>";
       print "<tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=15 cols=53 class=comment></textarea></td></tr>\n";
       print "<td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
       print "</tr></table>\n";
       print "</td></tr></table>\n";
       print "</form>\n";
    }
    print "<script language=\"javascript\">document.inputForm.passwd.focus();</script>\n";               
      
    &html_foot;
}

##########################################################################
# ȭϿ Է  Ѵ.
##########################################################################
sub write_data {
    require "./lib/cm_make_crypt_password.cgi";
    require "./lib/cm_get_num_info.cgi";
    require "./lib/cm_put_num_info.cgi";
	
    &get_num_info;
    &getVariable;
    &make_crypt_password if($passwd);
    &makeNewFile;
    &appendIndexFile;
    $gNoOfData++;
    &put_num_info($gNoOfData);

    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<meta http-equiv=refresh content=0;url=bdr_link.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
    print "</html>\n";
}

##########################################################################
# Է  ´
##########################################################################
sub getVariable {
   require "./lib/cm_alert.cgi";
	
# ȣ	
    if($FORM{'passwd'}) {
        $passwd = "$FORM{'passwd'}";
    }
#    else {
#        $msg = "Password ݵ ּ."; 
#        alert($msg);
#    }
        
# 
    unless($FORM{'subject'} =~ /^\s*$/) {
        $subject = "$FORM{'subject'}";
        $sbuject =~ s/\|/&#124;/g;
        $subject =~ s/\r\n\r\n/<p>/g;
        $subject =~ s/\r\n/<br>/g;
    }
    else {
        $msg = " ݵ ּ."; 
        alert($msg);
    }

# 
    if($FORM{'content'}) {
       $content = "$FORM{'content'}";
       $content =~ s/\|/&#124;/g;
       $content =~ s/\r\n\r\n/<p>/g;
       $content =~ s/\r\n/<br>/g;
    }
    else {
        $msg = " ݵ ּ."; 
        alert($msg);
    }
        
# ̸
    if($FORM{'email'}) {
        $email = "$FORM{'email'}";
        $email =~ s/\|/&#124;/g;
    }
    else {
        $email = "";
    }
    
# Ȩ
    if($FORM{'homepage'}) {
       if($FORM{'homepage'} eq 'http://') {
       	  $homepage = "";
       }
       else {
          $homepage = "$FORM{'homepage'}";
          $homepage =~ s/\|/&#124;/g;
        }
    }
    else {
        $msg = "Ȩ ݵ ּ."; 
        alert($msg);
    }
    
# 
    if($FORM{'banner'}) {
      if($FORM{'banner'} eq 'URL') {
        $banner = "";
      }
      else {
        $banner = "$FORM{'banner'}";
        $banner =~ s/\|/&#124;/g;
      }
    }
    else {
        $banner = "";
    }

# ó
    if($FORM{'phone'}) {
        $phone = "$FORM{'phone'}";
        $phone =~ s/\|/&#124;/g;
    }
    else {
        $phone = "";
    }
    
#     
    if($FORM{'Items'}) {
        $Items = "$FORM{'Items'}";
        $Items =~ s/\|/&#124;/g;
      }

    $ip = $ENV{'REMOTE_ADDR'};    
}

##########################################################################
#  α δ
##########################################################################
sub show_user_ogin {
    require "./lib/cm_html_head.cgi";
    
    local($command);

    if($FORM{'c'} eq "delete") {
        $command = "delete";
    }
    else {
        $command = "show_update_form";
    }
 
    &html_head("bdr_link");
    print "<TABLE WIDTH=220 valign=top align=center border=0 background=$gIMG_Link/m_bg.gif>\n";    
    print "<tr><td align=center valign=top>\n";        	    
    print "<form method=post name=userlogin action=bdr_link.cgi>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=action value=$command>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print "<center><br><b> </b><br><br><center>\n" if($command eq "delete");
    print "<center><br><b> </b><br><br><center>\n" if($command eq "show_update_form");
    print "<font color=$gTextColor>йȣ </font>\n";
    print "<input type=password name=passwd size=12 maxlength=16> \n";
    print "</td></tr>\n";
    print "<tr><td align=right valign=top>\n";        
    print "<input type=submit value=\" Ȯ  \">\n";
    print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";        
    print "</form>\n";
    print "<br><br><br><br></td></tr></table>\n";        
    print "<script language=\"javascript\">document.userlogin.passwd.focus();</script>\n";    
    &html_foot;       
}

##########################################################################
# ϵ ȭ Ѵ
##########################################################################
sub delete_data {
    require "./lib/cm_lock.cgi";
    require "./lib/cm_get_num_info.cgi";    
    require "./lib/cm_put_num_info.cgi";
	
    local(@datum,@value);
 
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
    
    &lock("$FORM{'db'}_data");    
    open(HANDLE,">$gBaseDIR/$gDatFile");
    foreach $data (@datum) {
        @value = split(/\|/, $data);
        if($FORM{'l'} != $value[1]) {
            print HANDLE "$data";             
        }
    }
    close(HANDLE);
    &unlock("$FORM{'db'}_data");
    
    unlink("$gBaseDIR/data/$FORM{'l'}.cgi");

    &get_num_info;
    $gNoOfData--;
    &put_num_info($gNoOfData);

    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<meta http-equiv=refresh content=0;url=bdr_link.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
    print "</html>\n";
}

##########################################################################
# ϵ ȭ  Ʈ 
##########################################################################
sub show_update_form {
    require "./lib/cm_html_head.cgi";
    require "./lib/cm_get_cookie.cgi";
    
    local($data,$name,$value);
    local(@cookies);
    
    # Ű б
    local(@value);
    &get_cookie;
 
    open(HANDLE,"$gBaseDIR/data/$FORM{'l'}.cgi");
        $data = <HANDLE>;
    close(HANDLE);
    @value = split(/\|/,$data);             

    &html_head("bdr_link");
    print "<br><table border=1 width=450 bgcolor=#eeeeee bordercolorlight=#cccccc bordercolordark=#ffffff cellspacing=0 cellpadding=5 align=center>\n";    
    print "<tr><td align=center>\n";    
    print "<form method=post  name=updateform action=bdr_link.cgi>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
    print "<input type=hidden name=action value=update>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print "<input type=hidden name=OldPassword value=$value[0]>\n";

    print "<table border=0 cellspacing=1 cellpadding=2 align=center>\n";    
              
    if (int($gItem) > 1) {  # 2
      if(($value[10] eq "") || ($value[10] eq "Item1")) {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1 selected>$gItem1";
         print "<option value=Item2>$gItem2";
         print "</select>\n";
         print "</td></tr>\n";
      }
      if($value[10] eq "Item2") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1>$gItem1";
         print "<option value=Item2 selected>$gItem2";
         print "</select>\n";
         print "</td></tr>\n";
      }            
    }
     
    if (int($gItem)> 2) {  # 3
      if($value[10] eq "Item3") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3 selected>$gItem3";         
         print "</select>\n";
         print "</td></tr>\n";
      }                  
    }
    
    if (int($gItem)> 3) { # 4
      if($value[10] eq "Item4") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";         
         print "<option value=Item4 selected>$gItem4";                  
         print "</select>\n";
         print "</td></tr>\n";
      }                       
    }
         
    if (int($gItem)> 4) {  # 5
      if($value[10] eq "Item5") {
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";         
         print "<option value=Item4>$gItem4";                  
         print "<option value=Item5 selected>$gItem5";                                             
         print "</select>\n";
         print "</td></tr>\n";
      }                             
    }

    if (int($gItem)> 5) { # 6
      if($value[10] eq "Item6") {
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";         
         print "<option value=Item4>$gItem4";                  
         print "<option value=Item5>$gItem5";                                             
         print "<option value=Item6 selected>$gItem6";                                             
         print "</select>\n";
         print "</td></tr>\n";         
      }                                   
    }
    
    if (int($gItem)> 6) { # 7
      if($value[10] eq "Item7") {
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";         
         print "<option value=Item4>$gItem4";                  
         print "<option value=Item5>$gItem5";                                             
         print "<option value=Item6>$gItem6";                                             
         print "<option value=Item7 selected>$gItem7";
         print "</select>\n";
         print "</td></tr>\n";         
      }                                         
    }    
    
    if (int($gItem)> 7) {  # 8
      if($value[10] eq "Item8") {
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";         
         print "<option value=Item4>$gItem4";                  
         print "<option value=Item5>$gItem5";                                             
         print "<option value=Item6>$gItem6";                                             
         print "<option value=Item7>$gItem7";
         print "<option value=Item8 selected>$gItem8";
         print "</select>\n";
         print "</td></tr>\n";         
      }                                               
    }            
    
    #  ŸԿ  Է ޶.
    if(($gLinkType eq "0") || ($gLinkType eq "weblink")) {
       print "<input type=hidden name=passwd size=20 maxlength=16 class=text value=\"$value[0]\">\n";
       print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
       print "<input name=homepage type=text value=\"$value[8]\" size=53 type=text class=text></td></tr>\n";
       print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
       print "<input type=hidden name=phone value=\"$value[3]\">\n";                             # Ӽ : ó
       print "<input name=email value=\"$value[4]\" type=text size=53 class=text></td></tr>\n";               
       print "</td></tr><tr><td align=right><span class=cls><b>Subject</b></span></td><td>\n";
       $value[2] =~ s/<br>/\n/g;
       $value[2] =~ s/<p>/\n\n/g;
       print "<input name=subject value=\"$value[2]\" type=text size=53 value='' class=text></td></tr>\n";
       $value[6] =~ s/<br>/\n/g;
       $value[6] =~ s/<p>/\n\n/g;       
       print "<tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=15 cols=53 class=comment>$value[6]</textarea></td>\n";    
       print "</tr><tr><td align=right><span class=cls><b>Banner URL</b></span></td><td>\n";
       print "<input name=banner value=\"$value[9]\" type=text size=53 class=text>\n";
       print "</td></tr><tr>\n";
       print "<td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
       print "</tr></table>\n";
       print "</td></tr></table>\n";
       print "</form>\n";
       print "<script language=\"javascript\">document.updateform.homepage.focus();</script>\n";     
     }
     elsif(($gLinkType eq "1") || ($gLinkType eq "linklist")) {
       print "<input type=hidden name=passwd size=53 maxlength=16 class=text value=\"$value[0]\">\n";     	
       print "<tr><td align=right><span class=cls><b>Name</b></span></td><td>\n";
       $value[2] =~ s/<br>/\n/g;
       $value[2] =~ s/<p>/\n\n/g;
       print "<input name=subject value=\"$value[2]\" type=text size=53 value='' class=text></td>\n";
       print "</tr>\n";
       print "<tr><td align=right><span class=cls><b>Phone</b></span></td><td>\n";
       print "<input name=phone value=\"$value[3]\" type=text size=53 class=text>\n";
       print "<input type=hidden name=banner value=\"$value[9]\">\n";                             # Ӽ : 
       print "</td></tr>\n";
       print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
       print "<input name=email value=\"$value[4]\" type=text size=53 class=text></td></tr>\n";                
       print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
       print "<input name=homepage type=text value=\"$value[8]\" size=53 type=text class=text></td></tr>\n";
       print "<tr>\n";
       $value[6] =~ s/<br>/\n/g;
       $value[6] =~ s/<p>/\n\n/g;
       print "<td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=15 cols=53 class=comment>$value[6]</textarea></td></tr>\n";    
       print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
       print "</tr></table>\n";
       print "</td></tr></table>\n";
       print "</form>\n";
       print "<script language=\"javascript\">document.updateform.subject.focus();</script>\n";     
     }
    &html_foot;       
}

##########################################################################
#  ȭ Ѵ
##########################################################################
sub makeNewFile { 
    local(@set);

    require "./lib/cm_lock.cgi";
    require "./lib/cm_get_date.cgi";
    &get_date;
    
    @set = ('0'..'9'); 
    srand(time);
    $gRandomFilename = "$d$set[rand(10)]$set[rand(10)]$set[rand(10)]$set[rand(10)]$set[rand(10)]$set[rand(10)]";
    
    &lock("$FORM{'db'}_newfile");    
    open(HANDLE,">$gBaseDIR/data/$gRandomFilename.cgi");
        print HANDLE "$gCryptPassword|$gRandomFilename|$subject|$phone|$email|$date|$content|$ip|$homepage|$banner|$Items||||||\n";
    close(HANDLE);
    &unlock("$FORM{'db'}_newfile");    
}

##########################################################################
# ȭϿ  Ѵ
##########################################################################
sub appendIndexFile {
    local($data);
    local(@datum,@point);

    require "./lib/cm_lock.cgi";

    &lock("$FORM{'db'}_data");
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
    
    if($FORM{'l'}) {    # 亯 ߰ 
        open(HANDLE,">$gBaseDIR/$gDatFile");
        foreach $data (@datum) {
            @point = split(/\|/,$data);
            if($point[1] eq $FORM{'l'}) {
                $thread = $point[0] + 1;
                print HANDLE "$data";
	    print HANDLE "$thread|$gRandomFilename|\n";	    
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
     }
     else {
        open(HANDLE,">$gBaseDIR/$gDatFile");
        foreach $data (@datum) {
            if($data =~ /<!--EOF-->/) {
                print HANDLE "<!--EOF-->\n";
	        print HANDLE "0|$gRandomFilename|\n";	    
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
    }
    &unlock("$FORM{'db'}_data");
}

##########################################################################
# Ʈ  ϵ ȭ ã Ѵ
##########################################################################
sub update_data {
    require "./lib/cm_lock.cgi";
    	
    local(@datum,@value);

    &getVariable;

    &lock("$FORM{'db'}_data");
    open(HANDLE,"<$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);

    open(HANDLE,">$gBaseDIR/$gDatFile");
    foreach $data (@datum) {
        @value = split(/\|/,$data);
        if($FORM{'l'} eq $value[1]) {
#                                      0       |ȣ            |(̸)|ó|̸|¥        |  |ip|Ȩ       |       ||||||
            print HANDLE "$value[0]|$FORM{'l'}|\n";
        }
        else {
            print HANDLE "$data";
        }
    }
    close(HANDLE);
    &unlock("$FORM{'db'}_data");  

    &lock("$FORM{'db'}_data2");        
    open(HANDLE,">$gBaseDIR/data/$FORM{'l'}.cgi");
#                                               ȣ            |ȭϸ        |(̸)|ó|̸|¥  |       |ip|Ȩ      |      |||||||
        print HANDLE "$FORM{'OldPassword'}|$FORM{'l'}|$subject|$phone|$email|$date|$content|$ip|$homepage|$banner|$Items||||||\n";
    close(HANDLE);
    &unlock("$FORM{'db'}_data2");
    
    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<meta http-equiv=refresh content=2;url=bdr_link.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
    print "</html>\n";
}

##########################################################################
#  α
##########################################################################
sub show_admin_login {
    require "./lib/cm_html_head.cgi";
    
    &html_head("bdr_link");
    unless(open(HANDLE,"$gBaseDIR/$gPwdFile")) {
        print "<table width=220 valign=top align=center border=0 background=$gIMG_Link/m_bg.gif>\n";
        print "<tr><td align=center valign=top>\n";    	
        print "<br><form action=bdr_link.cgi name=passwdconfig>\n";
        print "<input type=hidden name=db value=$FORM{'db'}>\n";    
        print "<input type=hidden name=action value=$FORM{'c'}>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=new>\n";
        print "<b> йȣ </b><br><br>\n";
        print "<table border=0 width=150>\n";
        print "<tr><td width=50 align=left>йȣ</td><td align=left><input type=password name=newpasswd size=12 maxlength=16></td></tr>\n";
        print "<tr><td width=50 align=left>  </td><td align=left><input type=password name=repasswd size=12 maxlength=16></td></tr>\n";
        print "<tr><td width=50></td><td align=left><input type=submit value=\" Ȯ \"></td></tr>\n";
        print "</table>\n";
        print "</font></form>\n";
        print "<br></td></tr></table>\n";                    
        print "<script language=\"javascript\">document.passwdconfig.newpasswd.focus();</script>\n";                
    }
    else {
        print "<table width=220 valign=top align=center border=0 background=$gIMG_Link/m_bg.gif>\n";
        print "<tr><td align=center valign=top>\n";    	
        print "<br><form method=post name=config action=bdr_link.cgi>\n";
        print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
        print "<input type=hidden name=action value=$FORM{'c'}>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=old>\n";
        print "<b>ȯ漳/</b><br><br>\n";      
        print "<input type=radio name=action value=$FORM{'c'} checked style=\"background-color:#ffffff;border:1 solid white\"> ȯ漳 &nbsp;\n";
        print "<input type=radio name=action value=show_input_form style=\"background-color:#ffffff;border:1 solid white\"> ۾\n";
        print "<br><br>йȣ&nbsp;<input type=password name=oldpasswd size=12 maxlength=16>\n";
        print "</td></tr>\n";
        print "<tr><td align=right valign=top>\n";       
        print " <input type=submit value=\" Ȯ \">\n";
        print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";                    
        print "</form>\n";
        print "<br></td></tr></table>\n";                            
        print "<script language=\"javascript\">document.config.oldpasswd.focus();</script>\n";        
    }
    &html_foot;
    close(HANDLE);
}

##########################################################################
# ڿ  ȯ漳
##########################################################################
sub show_config_form {
    require "./lib/cm_html_head.cgi";
    
    &html_head("bdr_link");
    print "<table bgcolor=#000000 border=0 width=500 align=$gAlignType cellspacing=1 cellpadding=0><tr><td bgcolor=#ffffff>\n";    
    print "<br><br><b><font color=\"3355cc\"><center>Configuration For <b>$gSupervisor_HomeName</b></center></font></b><br><br>\n";
    print "<table border=0 width=100% align=center cellspacing=3 cellpadding=3><tr><td>\n";
    print "<form action=bdr_link.cgi>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n";
    print "<input type=hidden name=action value=config>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=ps value=new>\n";

# DB 
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: DB :: </b></td></tr>\n";
    print "<tr><td align=left>CGI Ÿ</td><td align=right><font color=#777777><b> ũ</b></font></td></tr>\n";    
    print "<tr><td align=left>DB</td><td align=right><font color=#cc7777><b>$FORM{'db'}</b></font></td></tr>\n";    
    print "<tr><td align=left>ȸ ٱ</td>\n";
    print "<td align=right><select name=UserType>\n";
    if($gUserType eq "type_member") {
        print "<option value=type_normal>&nbsp;&nbsp;";
        print "<option value=type_member selected>ٺҰ&nbsp;&nbsp;";
    }
    else {
        print "<option value=type_normal selected>&nbsp;&nbsp;";
        print "<option value=type_member>ٺҰ&nbsp;&nbsp;";
    }    
    print "</select></td></tr>\n";    
    print "<tr><td align=left>ũ Ÿ</td>\n";
    print "<td align=right><select name=LinkType>\n";
    if(($gLinkType eq "0") || ($gLinkType eq "weblink")) {
        print "<option value=weblink selected>&nbsp;&nbsp;ũ";
        print "<option value=linklist>ũƮ";
    }
    elsif(($gLinkType eq "1") || ($gLinkType eq "linklist")) {
        print "<option value=weblink>&nbsp;&nbsp;ũ";
        print "<option value=linklist selected>ũƮ";
    }
    print "</select></td></tr>\n";
    print "</table><br>\n";

# йȣ     
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: йȣ  :: </b></td></tr>\n";
    print "<tr align=right><td align=left>йȣ</td><td align=right><input type=password name=newpasswd size=12 maxlength=16>\n";
    print "<tr align=right><td align=left>Է</td><td align=right><input type=password name=repasswd size=12 maxlength=16>\n";
    print "</td></tr></table><br>\n";

######
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> ::   :: </b></td></tr>\n";
    print "<tr><td align=left></td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gBackColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=BackColor value=\"$gBackColor\" size=10></td></tr>\n";
    print "<tr><td align=left>ڻ</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTextColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TextColor value=\"$gTextColor\" size=10></td></tr>\n";
    print "<tr><td align=left> ̹ URL</td><td align=right><input type=text name=BackImgURL value=\"$gBackImgURL\" size=50></td></tr>\n";
    print "</table><br>\n";

### ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> ::   :: </b></td></tr>\n";

    print "<tr><td align=left>̺  </td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableTapBgcolor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TitleBack value=\"$gTableTapBgcolor\" size=9></td></tr>\n";
    print "<tr><td align=left>̺  ڻ</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableTapText\">&nbsp;&nbsp;</td></tr></table><input type=text name=TitleColor value=\"$gTableTapText\" size=9></td></tr>\n";    
    print "<tr><td align=left>̺ </td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableBgcolor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TableBgcolor value=\"$gTableBgcolor\" size=9></td></tr>\n";
    print "<tr><td align=left>̺ ڻ</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableTextr\">&nbsp;&nbsp;</td></tr></table><input type=text name=TableText value=\"$gTableText\" size=9></td></tr>\n";    
    print "<tr><td align=left>콺 ġ Խù </td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gActiveTableColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=ActiveTableColor value=\"$gActiveTableColor\" size=9></td></tr>\n";
    print "</table><br>\n";

###Display ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: Display  :: </b></td></tr>\n";
    print "<tr><td align=left></td>\n";
    print "<td align=right>";
    if($gTitleUse eq "YES") {         #  ȣȯ ؼ 
       $gTitleUse = "checked";
    }
    print "<input type=checkbox name=TitleUse value=checked $gTitleUse style=\"background-color:#ffffff;border:0\">̱&nbsp;";
    print "<input type=text name=TitleText value=\"$gTitleText\" size=12 maxlength=7 class=ad></td></tr>\n"; 

    print "<tr><td align=left> ۾</td>\n";
    print "<td align=right>";
    if($gUserUp eq "YES") {         #  ȣȯ ؼ 
       $gUserUp = "checked";
    }
    print "<input type=checkbox name=UserUp value=checked $gUserUp style=\"background-color:#ffffff;border:0\">\n";
    print "</td></tr>\n";    

    print "<tr><td align=left>IP</td>\n";
    print "<td align=right>";
    print "<input type=checkbox name=ShowIPInfo value=checked $gShowIPInfo style=\"background-color:#ffffff;border:0\">̱\n";    
    print "</td></tr>\n";            
        
    print "<tr><td align=left>Ĺ</td><td align=right><select name=AlignType>\n";
    if($gAlignType eq "left") {
        print "<option value=left selected>Left";
        print "<option value=center>Center";
        print "<option value=right>Right&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }    
    elsif($gAlignType eq "center" || $gAlignType eq "") {
        print "<option value=left>Left";
        print "<option value=center selected>Center";
        print "<option value=right>Right&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    elsif($gAlignType eq "right") {
        print "<option value=left>Left";
        print "<option value=center>Center";
        print "<option value=right selected>Right&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }    
    print "</select></td></tr>\n";                
    print "<tr><td align=left>ġ (ũ)</td><td align=right><select name=BannerLocation>\n";
    if($gBannerLocation eq "top") {
        print "<option value=top selected>";
        print "<option value=bottom>Ʒ";
        print "<option value=left>";
        print "<option value=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    elsif($gBannerLocation eq "bottom") {
        print "<option value=top>";
        print "<option value=bottom selected>Ʒ";
        print "<option value=left>";
        print "<option value=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }            
    elsif($gBannerLocation eq "left") {
        print "<option value=top>";
        print "<option value=bottom>Ʒ";
        print "<option value=left selected>";
        print "<option value=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }                
    else { # 
        print "<option value=top>";
        print "<option value=bottom>Ʒ";
        print "<option value=left>";
        print "<option value=right selected>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }                    
    print "</select></td></tr>\n";        
        
    print "<tr><td align=left>Table Size</td><td align=right><input type=text name=TableWidth value=\"$gTableWidth\" size=12 maxlength=4></td></tr>\n";
    print "<tr><td align=left>ǥ </td><td align=right><input type=text name=RecPerPage value=\"$gRecPerPage\" size=12 maxlength=2></td></tr>\n";
    print "<tr><td align=left>Ʈ  </td><td align=right><input type=text name=ListNumber value=\"$gListNumber\" size=12 maxlength=2></td></tr>\n";
    print "<tr><td align=left>뺸 &nbsp;&nbsp;&nbsp;&nbsp;(ũ帮Ʈ)</td><td align=right><input type=text name=PreviewWidth value=\"$gPreviewWidth\" size=12 maxlength=3></td></tr>\n";
    print "<tr><td align=left>뺸  (ũ帮Ʈ)</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gPreviewBgcolor\">&nbsp;&nbsp;</td></tr></table><input type=text name=PreviewBgcolor value=\"$gPreviewBgcolor\" size=9 maxlength=7></td></tr>\n";    
    print "<tr><td align=left>뺸 ڻ (ũ帮Ʈ)</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gPreviewTextcolor\">&nbsp;&nbsp;</td></tr></table><input type=text name=PreviewTextcolor value=\"$gPreviewTextcolor\" size=9 maxlength=7></td></tr>\n";
    
    print "</table><br>\n";

### з ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: з  :: </b></td></tr>\n";
    print "<tr><td align=left>з </td>\n";
    print "<td align=right><select name=Item>\n";
    if($gItem eq "0") {
        print "<option value=0 selected>з&nbsp;&nbsp;";
        print "<option value=1>1";
        print "<option value=2>2";
        print "<option value=3>3";
        print "<option value=4>4";
        print "<option value=5>5";
        print "<option value=6>6";
        print "<option value=7>7";
        print "<option value=8>8";
    }    
    elsif($gItem eq "1") {
        print "<option value=0>з&nbsp;&nbsp;";
        print "<option value=1 selected>1";
        print "<option value=2>2";
        print "<option value=3>3";
        print "<option value=4>4";
        print "<option value=5>5";
        print "<option value=6>6";
        print "<option value=7>7";
        print "<option value=8>8";
    }
    elsif($gItem eq "2") {
        print "<option value=0>з&nbsp;&nbsp;";    	
        print "<option value=1>1";
        print "<option value=2 selected>2";
        print "<option value=3>3";
        print "<option value=4>4";
        print "<option value=5>5";
        print "<option value=6>6";
        print "<option value=7>7";
        print "<option value=8>8";
    }    
    elsif($gItem eq "3") {
        print "<option value=0>з&nbsp;&nbsp;";    	
        print "<option value=1>1";
        print "<option value=2>2";
        print "<option value=3 selected>3";
        print "<option value=4>4";
        print "<option value=5>5";
        print "<option value=6>6";
        print "<option value=7>7";
        print "<option value=8>8";
    }    
    elsif($gItem eq "4") {
        print "<option value=0>з&nbsp;&nbsp;";    	
        print "<option value=1>1";
        print "<option value=2>2";
        print "<option value=3>3";
        print "<option value=4 selected>4";
        print "<option value=5>5";
        print "<option value=6>6";
        print "<option value=7>7";
        print "<option value=8>8";
    }    
    elsif($gItem eq "5") {
        print "<option value=0>з&nbsp;&nbsp;";    	
        print "<option value=1>1";
        print "<option value=2>2";
        print "<option value=3>3";
        print "<option value=4>4";
        print "<option value=5 selected>5";
        print "<option value=6>6";
        print "<option value=7>7";
        print "<option value=8>8";
    }    
    elsif($gItem eq "6") {
        print "<option value=0>з&nbsp;&nbsp;";    	
        print "<option value=1>1";
        print "<option value=2>2";
        print "<option value=3>3";
        print "<option value=4>4";
        print "<option value=5>5";
        print "<option value=6 selected>6";
        print "<option value=7>7";
        print "<option value=8>8";
    }    
    elsif($gItem eq "7") {
        print "<option value=0>з&nbsp;&nbsp;";    	
        print "<option value=1>1";
        print "<option value=2>2";
        print "<option value=3>3";
        print "<option value=4>4";
        print "<option value=5>5";
        print "<option value=6>6";
        print "<option value=7 selected>7";
        print "<option value=8>8";
    }    
    elsif($gItem eq "8") {
        print "<option value=0>з&nbsp;&nbsp;";    	
        print "<option value=1>1";
        print "<option value=2>2";
        print "<option value=3>3";
        print "<option value=4>4";
        print "<option value=5>5";
        print "<option value=6>6";
        print "<option value=7>7";
        print "<option value=8 selected>8";
    }                            
    print "</select></td></tr>\n";        
        
    print "<tr><td align=left>з ׸ 1</td><td align=right><input type=text name=Item1 value=\"$gItem1\" size=12 maxlength=10></td></tr>\n";
    print "<tr><td align=left>з ׸ 2</td><td align=right><input type=text name=Item2 value=\"$gItem2\" size=12 maxlength=10></td></tr>\n";
    print "<tr><td align=left>з ׸ 3</td><td align=right><input type=text name=Item3 value=\"$gItem3\" size=12 maxlength=10></td></tr>\n";
    print "<tr><td align=left>з ׸ 4</td><td align=right><input type=text name=Item4 value=\"$gItem4\" size=12 maxlength=10></td></tr>\n";
    print "<tr><td align=left>з ׸ 5</td><td align=right><input type=text name=Item5 value=\"$gItem5\" size=12 maxlength=10></td></tr>\n";
    print "<tr><td align=left>з ׸ 6</td><td align=right><input type=text name=Item6 value=\"$gItem6\" size=12 maxlength=10></td></tr>\n";
    print "<tr><td align=left>з ׸ 7</td><td align=right><input type=text name=Item7 value=\"$gItem7\" size=12 maxlength=10></td></tr>\n";
    print "<tr><td align=left>з ׸ 8</td><td align=right><input type=text name=Item8 value=\"$gItem8\" size=12 maxlength=10></td></tr>\n";            
    print "</table><br>\n";
    print "</td></tr></table>\n";
    print "</td></tr></table><br><br>\n";

    print "<center><input type=submit value=\" Ȯ  \">\n";
    print "</form>\n";

    &html_foot;
}

##########################################################################
# ȯ漳 ƮѴ
##########################################################################
sub update_config_variables {
    require "./lib/cm_check_password.cgi";
	
    &check_admin_password if($FORM{'newpasswd'} || $FORM{'repassword'});

    $gLinkType = $FORM{'LinkType'};
    $gBackColor = $FORM{'BackColor'};
    $gTextColor = $FORM{'TextColor'};
    $gBackImgURL = $FORM{'BackImgURL'};
    $gTitleText = $FORM{'TitleText'};
    $gTableText = $FORM{'TableText'};
    $gTableWidth = $FORM{'TableWidth'};         
    $gRecPerPage = $FORM{'RecPerPage'} if($FORM{'RecPerPage'} >= 1);
    $gListNumber = $FORM{'ListNumber'};
    $gTableTapText = $FORM{'TitleColor'};
    $gActiveTableColor = $FORM{'ActiveTableColor'};
    $gTitleUse = $FORM{'TitleUse'};
    $gAlignType = $FORM{'AlignType'};
    $gTableTapBgcolor = $FORM{'TitleBack'};
    $gItem = $FORM{'Item'};
    $gItem1 = $FORM{'Item1'};
    $gItem2 = $FORM{'Item2'};
    $gItem3 = $FORM{'Item3'};
    $gItem4 = $FORM{'Item4'};
    $gItem5 = $FORM{'Item5'};
    $gItem6 = $FORM{'Item6'};    
    $gItem7 = $FORM{'Item7'};    
    $gItem8 = $FORM{'Item8'};    
    $gUserUp = $FORM{'UserUp'};
    $gUserType = $FORM{'UserType'};
    $gTableBgcolor = $FORM{'TableBgcolor'};
    $gBannerLocation = $FORM{'BannerLocation'};            
    $gPreviewWidth = $FORM{'PreviewWidth'};
    $gPreviewBgcolor = $FORM{'PreviewBgcolor'};
    $gPreviewTextcolor = $FORM{'PreviewTextcolor'};
    $gShowIPInfo = $FORM{'ShowIPInfo'};
        
    $gTempColor4 = $FORM{'TempColor4'};    
    $gTempYesOrNo1 = $FORM{'TempYesOrNo1'};    
    $gTempYesOrNo2 = $FORM{'TempYesOrNo2'};
    $gTempYesOrNo4 = $FORM{'TempYesOrNo4'};
    $gTempURL2 = $FORM{'TempURL2'} if($FORM{'TempURL2'} =~ /^http:\/\// || $FORM{'TempURL2'} eq "");
        
    &putEnvVar;
    $gCurPage = $FORM{'p'};

    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<meta http-equiv=refresh content=\"0;url=bdr_link.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}\">\n";
    print "</html>\n";
}

#ũ
#value0 = 0
#value1 = ȭ
#value2 = ̸/
#value3 = ó
#value4 = ̸
#value5 = ð
#value6 = 
#value7 = IP
#value8 = Ȩ
#value9 = 
#value10 = 
#value11 = 
#value12 = 
#valueAlignType = 
#value14 = 
#value15 = 