#!/usr/bin/perl

require "./lib/cm_get_supervisor_config.cgi";
################################################################################

&parseArgument;

sub parseArgument {
    require "./lib/cm_parse2.cgi";    
        	
    local (%FORM); 
     
    &parse2;

    $gCfgFile = "admin_cfg.cgi";
    $gPwdFile = "admin_pwd.cgi";
    
    &selectAction;
}

sub selectAction { 
    require "./lib/cm_get_cookie.cgi";
    require "./lib/cm_check_password.cgi";
    
    require "./lib/cm_alert.cgi";
     
    &get_cookie;    	    
    &get_config_variables;

    #  üũ
    if((&check_supervisor_password("$COOKIE{'ROOTADMIN'}") eq "false") && ($FORM{"action"} eq "config_form")) {
       &check_password ($FORM{"ps"} ne "new");
    }
        
    if($FORM{"action"} eq "config_form") {     # ȯ漳    	
          &show_admin_config_form; 
    }        
    elsif($FORM{"action"} eq "loading_form") { 
          &show_loading_form; 
    }    
    elsif($FORM{"action"} eq "make_db") {
          &makeDB; 
    }
    elsif($FORM{"action"} eq "delete_db") { 
          &deleteDB; 
    }
    elsif($FORM{"action"} eq "log_out") { 
          &logout; 
    }
    elsif($FORM{'action'} eq "put_config") {    	  
          &update_config_variables;
    }
    else { 
          &show_admin_login_form; 
    }
}

##########################################################################
# bdr_admin ȯ漳 оδ. (cm_get_supervisor_config.cgi ũ )
##########################################################################
sub get_config_variables {
    local($env_list);
    local(@datum);

    if(open(HANDLE,"<$gCfgFile")) {
        $env_list = <HANDLE>;
        close(HANDLE);
        @datum = split(/\|/,$env_list);

        $gSupervisor_Name = $datum[1];
        $gSupervisor_Homepage = $datum[2];
        $gSupervisor_HomeName = $datum[3];
        $gSupervisor_EMail = $datum[4];       
        $gIMG_CGI = $datum[12];
        $gIMG_Board = $datum[13];
        $gIMG_Guest = $datum[14];
        $gIMG_Link = $datum[15];
        $gIMG_FileType = $datum[16];        
        $gVerCGI = $datum[17];
        $gVerMail = $datum[18];
        $gVerGuest = $datum[19];
        $gVerLink = $datum[20];
        $gVerBoard = $datum[21];
        
        $gUploadDIR = $datum[24];
        $gUploadURL = $datum[25];
        $gSENDMAIL = $datum[26];
        $gWelcomeToMemberHTML = $datum[27];
        $gRegisterType = $datum[28];
        $gIsTel = $datum[29];
        $gIsAddress = $datum[30];        
        $gIMG_Emoticon = $datum[31];     

        $gTemp05 = $datum[5];
        $gTemp06 = $datum[6];
        $gTemp07 = $datum[7];
        $gTemp08 = $datum[8];
        $gTemp09 = $datum[9];
        $gTemp10 = $datum[10];
        $gTemp11 = $datum[11]; 
        $gTemp22 = $datum[22];        
        $gTemp23 = $datum[23];                  
        $gTemp32 = $datum[32];
        $gTemp33 = $datum[33];
        $gTemp34 = $datum[34];
        $gTemp35 = $datum[35];
        $gTemp36 = $datum[36];
        $gTemp37 = $datum[37];
        $gTemp38 = $datum[38];
        $gTemp39 = $datum[39];
        $gTemp40 = $datum[40];
        $gTemp41 = $datum[41];
        $gTemp42 = $datum[42];
        $gTemp43 = $datum[43];
        $gTemp44 = $datum[44];
        $gTemp45 = $datum[45];
        $gTemp46 = $datum[46];
        $gTemp47 = $datum[47];
        $gTemp48 = $datum[48];
        $gTemp49 = $datum[49];
        $gTemp50 = $datum[50];
    }
    else {
        # ʱ ȯ 
        $gSupervisor_Name = "";
        $gSupervisor_Homepage = "http://";
        $gSupervisor_HomeName = "My World";
        $gSupervisor_EMail = "";               
        $gIMG_CGI = "./img";
        $gIMG_Board = "$gIMG_CGI/board";
        $gIMG_Guest = "$gIMG_CGI/guest";
        $gIMG_Link = "$gIMG_CGI/link";
        $gIMG_FileType = "$gIMG_CGI/filetype";        
        $gVerCGI = "v1.4+";
        $gVerMail = "v1.1";
        $gVerGuest = "v2.5+";
        $gVerLink = "v2.3+";
        $gVerBoard = "v1.6+";
        $gUploadDIR = "./upload";
        $gUploadURL = "http://.../upload";
        $gSENDMAIL = "/usr/sbin/sendmail";
        $gWelcomeToMemberHTML = "./member.htm";
        $gRegisterType = "checked";
        $gIsTel = "";
        $gIsAddress = "";
        $gIMG_Emoticon = "./img/emoticon";

        $gTemp05 = "";
        $gTemp06 = "";
        $gTemp07 = "";
        $gTemp08 = "";
        $gTemp09 = "";
        $gTemp10 = "";
        $gTemp11 = "";     
        $gTemp22 = "";        
        $gTemp23 = "";           
        $gTemp32 = "";
        $gTemp33 = "";
        $gTemp34 = "";
        $gTemp35 = "";
        $gTemp36 = "";
        $gTemp37 = "";
        $gTemp38 = "";
        $gTemp39 = "";
        $gTemp40 = "";
        $gTemp41 = "";
        $gTemp42 = "";
        $gTemp43 = "";
        $gTemp44 = "";
        $gTemp45 = "";
        $gTemp46 = "";
        $gTemp47 = "";
        $gTemp48 = "";
        $gTemp49 = "";
        $gTemp50 = "";
                
        &put_config_variables;
    }
}

##########################################################################
# bdr_admin ȯ漳 ȭϿ Ѵ.
########################################################################## 
sub put_config_variables {
    require "./lib/cm_lock.cgi";	
    
    &lock("admin_cfg");
    open(HANDLE,">$gCfgFile");
        print HANDLE "|$gSupervisor_Name|$gSupervisor_Homepage|$gSupervisor_HomeName|$gSupervisor_EMail|$gTemp05|$gTemp06|$gTemp07|$gTemp08|$gTemp09|$gTemp10|$gTemp11|$gIMG_CGI|$gIMG_Board|$gIMG_Guest|$gIMG_Link|$gIMG_FileType|$gVerCGI|$gVerMail|$gVerGuest|$gVerLink|$gVerBoard|$gTemp22|$gTemp23|$gUploadDIR|$gUploadURL|$gSENDMAIL|$gWelcomeToMemberHTML|$gRegisterType|$gIsTel|$gIsAddress|$gIMG_Emoticon|$gTemp32|$gTemp33|$gTemp34|$gTemp35|$gTemp36|$gTemp37|$gTemp38|$gTemp39|$gTemp40|$gTemp41|$gTemp42|$gTemp43|$gTemp44|$gTemp45|$gTemp46|$gTemp47|$gTemp48|$gTemp49|$gTemp50|\n";
    close(HANDLE);
    &unlock("admin_cfg");
}


#######################################################################
#  α 
#######################################################################
sub show_admin_login_form {
    require "./lib/cm_html_head.cgi";	
    require "./lib/cm_get_cookie.cgi";	
    
    &get_cookie;

    &html_head("bdr_admin");
    unless(open(HANDLE,"$gPwdFile")) {
        print "<table width=220 valign=top align=center border=0 background=$gIMG_CGI/m_bg.gif>\n";
        print "<tr><td align=center valign=top>\n";        	
        print "<br><form action=bdr_admin.cgi name=passwdconfig>\n";
        print "<input type=hidden name=action value=config_form>\n";       
        print "<input type=hidden name=ps value=new>\n";
        print "<b>ü  йȣ </b><br><br>\n";
        print "<table border=0 width=150>\n";
        print "<tr><td width=60 align=left>йȣ</td><td align=left><input type=password name=mypasswd size=12 maxlength=16></td></tr>\n";
        print "<tr><td width=60 align=left>  </td><td align=left><input type=password name=repasswd size=12 maxlength=16></td></tr>\n";
        print "<tr><td width=60></td><td align=left><input type=submit value=\" Ȯ \"></td></tr>\n";
        print "</table>\n";
        print "</font></form>\n";
        print "<br></td></tr></table>\n";            
        print "<script language=\"javascript\">document.passwdconfig.mypasswd.focus();</script>\n";                        
    }    	    
    else {
        print "<table width=220 valign=top align=center border=0 background=$gIMG_CGI/m_bg.gif>\n";
        print "<tr><td align=center valign=top>\n";        	    	
        print "<br><form method=post action=bdr_admin.cgi name=config>\n";
        print "<input type=hidden name=action value=config_form>\n";
        print "<input type=hidden name=ps value=old>\n";
        print "<b>ü  </b><br>\n";
        print "<br>йȣ&nbsp;<input type=password name=mypasswd size=12 maxlength=16>\n";
        print "</td></tr>\n";
        print "<tr><td align=right valign=top>\n";                    
        print " <input type=submit value=\" Ȯ \">\n";
        print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
        print "</form>\n";
        print "<br><br><br><br></td></tr></table>\n";                    
        print "<script language=\"javascript\">document.config.mypasswd.focus();</script>\n";
    }
    &html_foot;
    close(HANDLE);

}

sub check_password {
    require "./lib/cm_lock.cgi";    
    require "./lib/cm_alert.cgi";
            	
    local($crypt_code,$save_password,$old_password,$my_password);
    local(@set);  
    
    if($FORM{'ps'} eq "new") { # йȣ űԷ
        if($FORM{'mypasswd'} eq $FORM{'repasswd'}) {        	
            if($FORM{'mypasswd'} ne "") {
                @set = ('a'..'z','A'..'Z','0'..'9','.','/');
                $crypt_code = "$set[9]$set[3]";
                $save_password = crypt($FORM{'mypasswd'},$crypt_code);

                &lock("admin_pwd");
                open(HANDLE,">$gPwdFile");
                    print HANDLE "$save_password\n";
	        close(HANDLE);
	        &unlock("admin_pwd");
            }
            else {
                $msg = " йȣ Է ʾҽϴ."; 
                alert($msg);
            }
        }
        else {
            $msg = " йȣ ġ ʽϴ."; 
            alert($msg);
        } 
    } 
    else {                               # йȣ Ȯ
        open(HANDLE,"<$gPwdFile");
            $save_password = <HANDLE>;
        close(HANDLE);
        chop($save_password);

        @set = ('a'..'z','A'..'Z','0'..'9','.','/');
        $crypt_code = "$set[9]$set[3]";
        $my_password = crypt($FORM{'mypasswd'},$crypt_code);

        unless($my_password eq $save_password) {
            $msg = " йȣ ġ ʽϴ."; 
            alert($msg);
        }
    }    
}

#######################################################################
#  α׾ƿ (Ű ʱȭ)
#######################################################################
sub logout {
       print "Set-Cookie:ROOTADMIN=0;\r\n";
       print "
              <html>
               <meta http-equiv=refresh content=\"0;url=bdr_admin.cgi\">
              </html>\n";      
}

##########################################################################
# ڿ  ȯ漳
##########################################################################
sub show_admin_config_form {
    require "./lib/cm_html_head.cgi";	

    if($FORM{'mypasswd'} eq "") {
       print "Set-Cookie:ROOTADMIN=$COOKIE{'ROOTADMIN'};\r\n";    
    }
    else {
       print "Set-Cookie:ROOTADMIN=$FORM{'mypasswd'};\r\n";    
    }
    &html_head("bdr_admin");

    &readDB;
    
    &html_foot;
}

##########################################################################
# ̺ д´.
##########################################################################
sub readDB {    
    print "
    <br><center>Configuration For <b>$gSupervisor_HomeName</b></center><br><br>
    <script language=JavaScript>
    	function memberwin(URL) {
    	  window.open(URL, 'memberwin', 'resizable=no, scrollbars=yes, status=0, width=670, height=600');
    	}
    	function verChk(URL) {
    	  window.open(URL, 'verChk', 'resizable=no, scrollbars=no, status=0, width=400, height=200');
    	}		
    	function confirmDelete() {
    	  if(confirm(' Ŀ  Ұմϴ. Ͻðڽϱ?')) 
    	     return true;
    	  return false;
    	}		
    	function NotFoundMemberList() {
              window.alert(' ϵ ȸ ϴ.');
    	}		
    </script>
    
    <DIV ALIGN=CENTER>
    <table border=0 width=600 cellspacing=1 cellpadding=0>	
     <tr>
      <td align=right><a href=bdr_admin.cgi?action=log_out><img src=$gIMG_CGI/logout.gif border=0></a></td>
     </tr>
    </table>";
    
    ################################# ȸ    			
    print "
    <table border=0 width=600 bgcolor=gray cellspacing=1 cellpadding=1>
    <tr>
     <td align=center bgcolor=#bfbfbf width=120><font face=><b>ȸ</b></font></td>
     <td bgcolor=white align=right valign=middle>";
    
    if(!-e "./members/member_list.cgi") {
      print "     <INPUT TYPE=BUTTON value='   ' onclick=javascript:NotFoundMemberList()>";
    }
    else {
      print "     <INPUT TYPE=BUTTON value='   ' onclick=javascript:memberwin('bdr_member.cgi?&action=member_list')>";
    }
    print "     </td></tr>\n";	
    
    ################################# DB
    print "
    <FORM action=bdr_admin.cgi method=post name=createDB>
    <INPUT TYPE=HIDDEN NAME=action VALUE=make_db>
    <tr>
     <td align=center bgcolor=#aaaaaa width=120><font face=><b>DB&nbsp;</b></font></td>
     <td bgcolor=white align=right valign=middle>
      DB Name : <input type=text name=db value='' size=10 maxlength=18>
      <select name=DBType>
       <option value=Board selected>Խ&nbsp;
       <option value=Guest>&nbsp;
       <option value=WebLink>ũ&nbsp;
      </select>		 	 
      <input type=submit value='   ' onclick=\"return DBCheckField();\"></td>
    </tr>
    </form>
    <script language=javascript>document.createDB.db.focus();</script>
    </table>
    
    <table border=0 width=600 bgcolor=#dddddd cellspacing=1 cellpadding=1>
    <tr>
    <td width=40 bgcolor=#cccccc align=center><font face=><strong>NO</strong></font></td>
    <td width=150 bgcolor=#cccccc align=center><font face=><strong>DB Name</strong></font></td>
    <td width=190 bgcolor=#cccccc align=center><font face=><strong>Type</strong></font></td>
    <td width=100 bgcolor=#cccccc align=center><font face=><strong>Articles</strong></font></td>
    <td width=40 bgcolor=#cccccc align=center><font face=><strong></strong></font></td>
    <td width=40 bgcolor=#cccccc align=center><font face=><strong></strong></font></td>
    <td width=40 bgcolor=#cccccc align=center><font face=><strong></strong></font></td>
    </tr>\n";
    
    opendir(DIRECTORY, "./db");
    @DATA = readdir(DIRECTORY);
    closedir(DIRECTORY);
    
    foreach (@DATA) {
    	if($_ ne "." && $_ ne ".." ) {
    		$i++;
    
           $filename = "$_\_num.cgi";                                               
    	   	open (HANDLE, "<./db/$_/$filename");
    	   	$NUM = <HANDLE>;
    	   	close(HANDLE);
           
           $filename = "$_\_cfg.cgi";
    	   	open (HANDLE, "<./db/$_/$filename");
    	   	$data = <HANDLE>;
    	   	close(HANDLE);
    	   	@value = split(/\|/, $data);

           if($value[12] eq "board") {
              if(($value[28] eq "show") || ($value[29] eq "show")) {
           	  if(($value[20] eq "type_member")  || ($value[20] eq "type_only_read")) {
           	  	
                    $TYPE = "ڷ (ȸ)";
                 }            
                 else {
                    $TYPE = "ڷ";
                 }
              }
              else {
           	  if(($value[20] eq "type_member") || ($value[20] eq "type_only_read")) {
                    $TYPE = "Խ (ȸ)";
                 }            
                 else {
                   $TYPE = "Խ";
                 }
              }               
           }
           elsif($value[12] eq "style1") {
                 $TYPE = " (Ÿ1)";
           }
           elsif($value[12] eq "style2") {
                 $TYPE = " (Ÿ2)";
           }
           elsif($value[12] eq "style3") {
                 $TYPE = " (Ÿ3)";
           }
           elsif($value[12] eq "weblink") {
               if($value[20] eq "type_member") {            	
                  $TYPE = "ũ (ȸ)";
               }
               else {
                  $TYPE = "ũ";                	
               }
           }
           elsif($value[12] eq "linklist") {
               if($value[20] eq "type_member") {            	
                  $TYPE = "ũƮ (ȸ)";
               }
               else {
                  $TYPE = "ũƮ";                	
               }
           }
                              
           print "<tr>
             <td width=30 bgcolor=#eeeeee align=center>&nbsp;&nbsp;$i</td>
             <td width=100 bgcolor=white align=left>&nbsp;&nbsp;$_</td>
             <td width=150 bgcolor=white align=left>&nbsp;&nbsp;$TYPE</td>
             <td width=100 bgcolor=white align=right><font color=red>$NUM</font>&nbsp;&nbsp;</td>";
          
          if($value[12] eq "board") { 
             print "<td width=40 bgcolor=#eeeeee align=center><A HREF=\"bdr_board.cgi?db=$_&action=admin_login&p=1&c=show_config_form\" target=_blank><IMG SRC=$gIMG_CGI/a_config.gif border=0></a></td>
              <td width=40 bgcolor=#eeeeee align=center><A HREF=\"bdr_board.cgi?db=$_\" target=_blank><IMG SRC=$gIMG_CGI/a_view.gif border=0></a></td>";
          }
          elsif(($value[12] eq "style1") || ($value[12] eq "style2") || ($value[12] eq "style3")) { 
                print "<td width=40 bgcolor=#eeeeee align=center><A HREF=\"bdr_guest.cgi?db=$_&action=admin_login&p=1&c=show_config_form\" target=_blank><IMG SRC=$gIMG_CGI/a_config.gif border=0></a></td>
                 <td width=40 bgcolor=#eeeeee align=center><A HREF=\"bdr_guest.cgi?db=$_\" target=_blank><IMG SRC=$gIMG_CGI/a_view.gif border=0></a></td>";
          }
          elsif(($value[12] eq "weblink") || ($value[12] eq "linklist")) { 
           print "<td width=40 bgcolor=#eeeeee align=center><A HREF=\"bdr_link.cgi?db=$_&action=admin_login&p=1&c=show_config_form\" target=_blank><IMG SRC=$gIMG_CGI/a_config.gif border=0></a></td>
                 <td width=40 bgcolor=#eeeeee align=center><A HREF=\"bdr_link.cgi?db=$_\" target=_blank><IMG SRC=$gIMG_CGI/a_view.gif border=0></a></td>";
          }		                
    	   		
          print "<td width=40 bgcolor=#eeeeee align=center><A HREF=\"bdr_admin.cgi?action=delete_db&db=$_\" onclick=\"return confirmDelete();\"><IMG SRC=$gIMG_CGI/a_del.gif border=0></a></td>
                 </tr>";
          }
       }	              
       print "</table>\n\n";    
                          
       print "
          <table border=0 width=600 cellspacing=1 cellpadding=0>	
           <tr>
            <td align=right><br>
             <font size=2 class=myfont><a href=bdr_admin.cgi?action=config_form>[ΰħ]</a></font>            
             <font size=2 class=myfont><a href=javascript:verChk('http://beomdori.x-y.net/cgi-bin/bdr_cgi_ver_chk.cgi?vCgi=$gVerCGI&vMail=$gVerMail&vGuest=$gVerGuest&vLink=$gVerLink&vBoard=$gVerBoard')>[ֽŹ üũ]</a></font>
             <font size=2 class=myfont><a href=http://beomdori.x-y.net target=_blank>[Beomdori' Homepage]</a></font>
            </td>
           </tr>
          </table>";
          
          # admin_cfg.cgiκ  а κ    
          # 
          print "       
          <table border=0 width=600 bgcolor=gray cellspacing=1 cellpadding=1>
          <form action=bdr_admin.cgi>
          <input type=hidden name=action value=put_config>
          <input type=hidden name=p value=$FORM{'p'}>
          <input type=hidden name=ps value=new>
          
          <tr>
          <td align=center bgcolor=#aaaaaa width=120><font face=><b> </b></font></td>
          <td bgcolor=white align=right valign=middle>
             <table width=100% border=0>
              <tr>
               <td> ̸</td><td align=right><input type=text name=Supervisor_Name value=\"$gSupervisor_Name\" size=20 maxlength=20></td>
              </tr>
              <tr>
               <td> ̸</td><td align=right><input type=text name=Supervisor_EMail value=\"$gSupervisor_EMail\" size=20 maxlength=20></td>
              </tr>	    	    	    
              <tr>
               <td> Ȩ</td><td align=right><input type=text name=Supervisor_Homepage value=\"$gSupervisor_Homepage\" size=50 maxlength=100></td>
              </tr>	    
              <tr>
               <td>Ȩ </td><td align=right><input type=text name=Supervisor_HomeName value=\"$gSupervisor_HomeName\" size=20 maxlength=20></td>
              </tr>
              <tr>
               <td colspan=2>йȣ : <input type=password name=mypasswd size=19 maxlength=12>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Է : <input type=password name=repasswd size=19 maxlength=12> <font size=1 color=#aaaaaa>(α ʿ)</font></td>
              </tr>
             </table>
           </td>
          </tr>\n";
          
          # CGI ġ 
          print "
          <tr>
          <td align=center bgcolor=#aaaaaa><font face=><b>CGI </b></font></td>
          <td bgcolor=white align=right valign=middle>
             <table width=100% border=0>
              <tr>
               <td>CGI Pakage</td><td align=right><input type=text name=VerCGI value=\"$gVerCGI\" size=5 maxlength=5 readonly></td>
              </tr>
              <tr>
               <td>Board CGI</td><td align=right><input type=text name=VerBoard value=\"$gVerBoard\" size=5 maxlength=5 readonly></td>
              </tr>
              <tr>
               <td>GuestBook CGI</td><td align=right><input type=text name=VerGuest value=\"$gVerGuest\" size=5 maxlength=5 readonly></td>
              </tr>
              <tr>
               <td>WebLink CGI</td><td align=right><input type=text name=VerLink value=\"$gVerLink\" size=5 maxlength=5 readonly></td>
              </tr>
              <tr>
               <td>Mail CGI</td><td align=right><input type=text name=VerMail value=\"$gVerMail\" size=5 maxlength=5 readonly></td>
              </tr>	    	    	    
             </table>
           </td>
          </tr>\n";
          
          # ̹ ġ 
          print "
          <tr>
          <td align=center bgcolor=#aaaaaa><font face=><b>̹ ġ </b></font></td>
          <td bgcolor=white align=right valign=middle>
             <table width=100% border=0>
              <tr>
               <td> ̹</td><td align=right><input type=text name=IMG_CGI value=\"$gIMG_CGI\" size=20 maxlength=20></td>
              </tr>
              <tr>
               <td> ̹</td><td align=right><input type=text name=IMG_Board value=\"$gIMG_Board\" size=20 maxlength=20></td>
              </tr>	    	    	    
              <tr>
               <td>Ͽ ̹</td><td align=right><input type=text name=IMG_Guest value=\"$gIMG_Guest\" size=20 maxlength=20></td>
              </tr>	    
              <tr>
               <td>ũ ̹</td><td align=right><input type=text name=IMG_Link value=\"$gIMG_Link\" size=20 maxlength=20></td>
              </tr>
              <tr>
               <td>ŸԿ ̹</td><td align=right><input type=text name=IMG_FileType value=\"$gIMG_FileType\" size=20 maxlength=20></td>
              </tr>
              <tr>
               <td≯Ƽܿ ̹</td><td align=right><input type=text name=IMG_Emoticon value=\"$gIMG_Emoticon\" size=20 maxlength=20></td>
              </tr>
             </table>
           </td>
          </tr>\n";	
          
          # 丮 
          print "
          <tr>
          <td align=center bgcolor=#aaaaaa><font face=><b>丮 </b></font></td>
          <td bgcolor=white align=right valign=middle>
             <table width=100% border=0>
              <tr>
               <td>ε 丮</td><td align=right><input type=text name=UploadDIR value=\"$gUploadDIR\" size=20 maxlength=20></td>
              </tr>	    
              <tr>
               <td>ε URL</td><td align=right><input type=text name=UploadURL value=\"$gUploadURL\" size=50 maxlength=100></td>
              </tr>
              <tr>
               <td≯ </td><td align=right><input type=text name=SENDMAIL value=\"$gSENDMAIL\" size=20 maxlength=20></td>
              </tr>
              
             </table>
           </td>
          </tr>\n";	
          
          # ȸ 
          print "
          <tr>
          <td align=center bgcolor=#aaaaaa><font face=><b>ȸ </b></font></td>
          <td bgcolor=white align=right valign=middle>
             <table width=100% border=0>
              <tr>
               <td>ȸ ȯ </td><td align=right><input type=text name=WelcomeToMemberHTML value=\"$gWelcomeToMemberHTML\" size=20 maxlength=20></td>
              </tr>             
              <tr>
               <td>Թ</td><td align=right><input type=checkbox name=RegisterType value=checked $gRegisterType style=\"background-color:#ffffff;border:0\"> </td>
              </tr>
              <tr>
               <td>ʼԷ</td><td align=right><input type=checkbox name=IsTel value=checked $gIsTel style=\"background-color:#ffffff;border:0\">ȭȣ&nbsp;
               <input type=checkbox name=IsAddress value=checked $gIsAddress style=\"background-color:#ffffff;border:0\">ּ&nbsp;</td>
              </tr>	      
             </table>
           </td>
          </tr>";
          
          print "	
          <tr>
           <td align=right colspan=2 bgcolor=#ffffff><input type=submit value=\" Ȯ  \"></td>
          </tr>       
       </table>
       </form></div>\n"; 
}

############################################################################
# DB
############################################################################
sub makeDB {
    require "./lib/cm_alert.cgi";
    require "./lib/cm_get_date.cgi";
        	
    if(!$FORM{'db'}) {
       $msg = " DB̸ Էϼž մϴ."; 
       alert($msg);
    }
    
    if( -e "./db/$FORM{'db'}") {
       $msg = "̹ ϴ DBԴϴ."; 
        alert($msg);
    }
    
    $dbname = $FORM{'db'};

    print "CONTENT-TYPE:TEXT/HTML\n\n";
    print "<html>\n<head>\n";                                             
    print "
           <script language=\"JavaScript\">
           <!--
               function newWindow() {
          ";
   
    if($FORM{'DBType'} eq "Board") { 
       print "      window.open('bdr_board.cgi?db=$dbname&action=admin_login&p=1&c=show_config_form', 'Window', 'width=800, height=600, scrollbars=yes, status=yes, toolbar=yes, location=yes, menubar=yes, directories=yes');";
    }
    elsif($FORM{'DBType'} eq "Guest") { 
       print "      window.open('bdr_guest.cgi?db=$dbname&action=admin_login&p=1&c=show_config_form', 'Window', 'width=800, height=600, scrollbars=yes, status=1, toolbar=1, location=1, menubar=1');";
    }
    elsif($FORM{'DBType'} eq "WebLink") { 
       print "      window.open('bdr_link.cgi?db=$dbname&action=admin_login&p=1&c=show_config_form', 'Window', 'width=800, height=600, scrollbars=yes, status=1, toolbar=1, location=1, menubar=1');";

    }
    
    print "
                   }
              // -->
              </script>
            </head>
           <body onload=\"newWindow()\">
           </body>
           </html>\n";
                                
#    print "CONTENT-TYPE:TEXT/HTML\n\n";
    print "<html>
           <meta http-equiv=\"refresh\" content =\"0;url=bdr_admin.cgi?action=loading_form&c=config_form\">
           </html>";
}

###############################################################################
# DB 
###############################################################################
sub deleteDB {
    opendir(DIRECTORY, "./db/$FORM{'db'}/data");
     @DATA = readdir(DIRECTORY);
    closedir(DIRECTORY);

    foreach $FILE (@DATA) {
      unlink("./db/$FORM{'db'}/data/$FILE");
    }  
    rmdir("./db/$FORM{'db'}/data");

    opendir(DIRECTORY, "./db/$FORM{'db'}");
      @DB = readdir(DIRECTORY);
    closedir(DIRECTORY);

    foreach $CGI (@DB) {
       unlink ("./db/$FORM{'db'}/$CGI");
    }  
    rmdir ("./db/$FORM{'db'}");
    
    print "CONTENT-TYPE:TEXT/HTML\n\n";
    print "<html>
            <meta http-equiv=\"refresh\" content=\"0;url=bdr_admin.cgi?action=loading_form&c=config_form\">
           </html>";
    exit;
}

##########################################################################
# ȯ漳 ƮѴ
##########################################################################
sub update_config_variables {
    local($reload_url);
    
    &check_password if($FORM{'mypasswd'} || $FORM{'repassword'});

    $gSupervisor_Name = $FORM{'Supervisor_Name'};
    $gSupervisor_Homepage = $FORM{'Supervisor_Homepage'};
    $gSupervisor_HomeName = $FORM{'Supervisor_HomeName'};
    $gSupervisor_EMail = $FORM{'Supervisor_EMail'};
    $gIMG_CGI = $FORM{'IMG_CGI'};
    $gIMG_Board = $FORM{'IMG_Board'};
    $gIMG_Guest = $FORM{'IMG_Guest'};
    $gIMG_Link = $FORM{'IMG_Link'};
    $gIMG_FileType = $FORM{'IMG_FileType'};
    $gVerCGI = $FORM{'VerCGI'};
    $gVerMail = $FORM{'VerMail'};
    $gVerGuest = $FORM{'VerGuest'};
    $gVerLink = $FORM{'VerLink'};
    $gVerBoard = $FORM{'VerBoard'};
    $gUploadDIR = $FORM{'UploadDIR'};
    $gUploadURL = $FORM{'UploadURL'};
    $gSENDMAIL = $FORM{'SENDMAIL'};
    $gWelcomeToMemberHTML = $FORM{'WelcomeToMemberHTML'};
    $gRegisterType = $FORM{'RegisterType'};
    $gIsTel = $FORM{'IsTel'};
    $gIsAddress = $FORM{'IsAddress'};    
    $gIMG_Emoticon = $FORM{'IMG_Emoticon'};

    $gTemp05 = $FORM{'Temp05'};
    $gTemp06 = $FORM{'Temp06'};
    $gTemp07 = $FORM{'Temp07'};
    $gTemp08 = $FORM{'Temp08'};
    $gTemp09 = $FORM{'Temp09'};
    $gTemp10 = $FORM{'Temp10'};
    $gTemp11 = $FORM{'Temp11'};  
    $gTemp22 = $FORM{'Temp22'};    
    $gTemp23 = $FORM{'Temp23'};      
    $gTemp32 = $FORM{'Temp32'};
    $gTemp33 = $FORM{'Temp33'};
    $gTemp34 = $FORM{'Temp34'};
    $gTemp35 = $FORM{'Temp35'};
    $gTemp36 = $FORM{'Temp36'};
    $gTemp37 = $FORM{'Temp37'};
    $gTemp38 = $FORM{'Temp38'};
    $gTemp39 = $FORM{'Temp39'};
    $gTemp40 = $FORM{'Temp40'};
    $gTemp41 = $FORM{'Temp41'};
    $gTemp42 = $FORM{'Temp42'};
    $gTemp43 = $FORM{'Temp43'};
    $gTemp44 = $FORM{'Temp44'};
    $gTemp45 = $FORM{'Temp45'};
    $gTemp46 = $FORM{'Temp46'};
    $gTemp47 = $FORM{'Temp47'};
    $gTemp48 = $FORM{'Temp48'};
    $gTemp49 = $FORM{'Temp49'};
    $gTemp50 = $FORM{'Temp50'};
            
    &put_config_variables;
    
    # йȣ ÿ ٽ αؾ 
    if($FORM{'mypasswd'} || $FORM{'repassword'}) {
       $reload_url = "bdr_admin.cgi";
    }
    else {
       $reload_url = "bdr_admin.cgi?action=loading_form&c=config_form";
    }
    
    print "Content-type: text/html\n\n";
    print "<html>\n";
    print " <meta http-equiv=refresh content=\"0;url=$reload_url\">\n";
    print "</html>\n";
}

sub show_loading_form {      	
    require "./lib/cm_loading_destination.cgi";

    # title, εURL, time, len, img_cnt, img_height
    loading_destination("ȯ漳 Ʈ","bdr_admin.cgi?action=$FORM{'c'}","0.5","200","20","5");
}
