#!/usr/bin/perl

################################################################################
#     Beomdori's GuestBook v2.5+
#
#     Programmer : BeomGyu, Lee
#     E-Mail     : cadeau@orgio.net
#     Homepage   : http://beomdori.x-y.net
#
################################################################################

require "./lib/cm_get_supervisor_config.cgi";
&get_supervisor_config;
################################################################################

umask(000);
&parseArgument;
sub parseArgument {
    require "./lib/cm_parse2.cgi";
    require "./lib/cm_alert.cgi";
    
    local($msg);

    &parse2;

    if($FORM{'db'}) {
    	$gBaseDIR = "./db/$FORM{'db'}";
        $gNumFile = "$FORM{'db'}_num.cgi";
        $gCfgFile = "$FORM{'db'}_cfg.cgi";
        $gPwdFile = "$FORM{'db'}_pwd.cgi";
        $gDatFile = "$FORM{'db'}_dat.cgi";
    }
    else {
           $msg = "ũϴ  : \"http\:\/\/\~\/bdr_guest.cgi?db=DB\"Դϴ.     "; 
           alert($msg);
    }
    
    if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
        close(HANDLE);
        require "./lib/cm_check_bdr_cgi.cgi";
	&check_bdr_cgi("bdr_guest");
        &selectAction;
    }
    else {
        require "./lib/cm_get_cookie.cgi";    	
        &get_cookie;    	
     
        require "./lib/cm_check_password.cgi";
        if(&check_supervisor_password("$COOKIE{'ROOTADMIN'}") eq "true") {
            &selectAction;
        }
        else {
           $msg = "ڸ DB   ֽϴ."; 
           alert($msg);        	        	
        }
    }
}

sub selectAction {
    require "./lib/cm_check_member.cgi";
    require "./lib/cm_check_password.cgi";
    require "./lib/cm_get_cookie.cgi";
    require "./lib/cm_get_num_info.cgi";
	
    &get_num_info;
    &getEnvVar;
    &get_cookie;
    
    unless($FORM{'action'}) {
        $FORM{'action'} = "r";
    }

    if($FORM{'action'} eq "r") {	
	&read_data;
    } 
    elsif($FORM{'action'} eq "show_user_input_form") {
        &show_user_input_form;
    }
    elsif($FORM{'action'} eq "write") {
	&write_data;
    } 
    elsif($FORM{'action'} eq "delete") {
        &check_user_password;
	&delete_data;
    } 
    elsif($FORM{'action'} eq "show_update_form") {
        &check_user_password;
	&show_update_form;
    } 
    elsif($FORM{'action'} eq "show_reply_form") {
        &check_admin_password;
	&showReplyForm;
    }    
    elsif($FORM{'action'} eq "update") {
	&update_data;
    } 
    elsif($FORM{'action'} eq "users_login") {
        &show_user_ogin;
    }
    elsif($FORM{'action'} eq "admin_login") {
            if(&check_supervisor_password("$COOKIE{'ROOTADMIN'}") eq "true") {
                  &show_config_form;         		
            }
            else {
                 &show_admin_login;
            }           	
    }
    elsif($FORM{'action'} eq "show_config_form") {
       &check_admin_password;
       &show_config_form;
	}
    elsif($FORM{'action'} eq "config") {
        &update_config_variables;
    }
    else {
        exit;
    }
}

##########################################################################
# bdr_guest ȯ漳 оδ.
##########################################################################
sub getEnvVar {
    local($env_list);
    local(@datum);

    if(open(HANDLE,"<$gBaseDIR/$gCfgFile")) {
        $env_list = <HANDLE>;
        close(HANDLE);
        @datum = split(/\|/,$env_list);

        $gBackColor = $datum[1];
        $gBackImgURL = $datum[2];
        
        $gDesignType = $datum[12];   # Ÿ
        
        $gRecPerPage = $datum[6];
        $gListNumber = $datum[7];

        $gTableWidth = $datum[5];
        $gTableBgcolor = $datum[21];
        $gTableText = $datum[15];
        $gActiveTableColor = $datum[14];
        $gTextColor = $datum[17];
        $gTitleUse = $datum[11];        

        $gAlignType = $datum[26];                # Display Ĺ
        
                                
        $gTempNum1 = $datum[20];   # 0 or 1                    
        $gTempURL2 = $datum[4];  
        $gTempURL3 = $datum[3];        
        $gTempURL4 = $datum[29];
        $gTempURL5 = $datum[30];
        $gTempURL6 = $datum[31];
        $gTempURL7 = $datum[32];
        $gTempURL8 = $datum[33];              
        $gTempURL9 = $datum[28];        
        $gTempColor1 = $datum[8];
        $gTempColor2 = $datum[9];
        $gTempColor3 = $datum[18];        
        $gTempColor4 = $datum[16];
        $gTempColor5 = $datum[22];
        $gTempColor6 = $datum[23];
        $gTempColor7 = $datum[10];                
        $gTempColor8 = $datum[27];                        
        $gTempColor9 = $datum[13];        
        $gTempYesOrNo1 = $datum[19];        
        $gTempYesOrNo2 = $datum[24];
        $gShowIPInfo = $datum[25];
        $gTempYesOrNo4 = $datum[36];        
        $gTempYesOrNo5 = $datum[35];                
        $gTempYesOrNo6 = $datum[34];
        chop($gHomeImageURL);
    }
    else {
        # ʱ ȯ 

        $gBackColor = "#ffffff";
        $gBackImgURL = "./img/guest/sy1_bg.gif";

        $gDesignType = "style1";           # Ÿ : style1, style2, style3
                
        $gTableWidth = "500";
        $gTableBgcolor = "#ffffff";
        $gTableText = "#000000";
        $gActiveTableColor = "#f5f5f5";
        $gTextColor = "#000000";
        $gTitleUse = "checked";           
        
        $gRecPerPage = "10";
        $gListNumber = "5";
        $gAlignType = "center";
        
        
        $gTempNum1 = "";       
        $gTempColor1 = "";
        $gTempColor2 = "";        
        $gTempColor3 = "";        
        $gTempColor4 = "";        
        $gTempColor5 = "";
        $gTempColor6 = "";
        $gTempColor7 = "";                
        $gTempColor8 = "";                        
        $gTempColor9 = "";                
        $gTempYesOrNo1 = "";
        $gTempYesOrNo2 = "";
        $gShowIPInfo = "";
        $gTempYesOrNo4 = "";
        $gTempYesOrNo5 = "";        
        $gTempYesOrNo6 = "";
        $gTempURL2 = "";
        $gTempURL3 = "";        
        $gTempURL4 = "";
        $gTempURL5 = "";
        $gTempURL6 = "";
        $gTempURL7 = "";
        $gTempURL8 = "";        
        $gTempURL9 = "";        
        &putEnvVar;
    }
}

##########################################################################
# bdr_guest ȯ漳 ȭϿ Ѵ.
########################################################################## 
sub putEnvVar {
    require "./lib/cm_lock.cgi";

    &lock("$FORM{'db'}_cfg");    	
    open(HANDLE,">$gBaseDIR/$gCfgFile");
        print HANDLE "|$gBackColor|$gBackImgURL|$gTempURL3|$gTempURL2|$gTableWidth|$gRecPerPage|$gListNumber|$gTempColor1|$gTempColor2|$gTempColor7|$gTitleUse|$gDesignType|$gTempColor9|$gActiveTableColor|$gTableText|$gTempColor4|$gTextColor|$gTempColor3|$gTempYesOrNo1|$gTempNum1|$gTableBgcolor|$gTempColor11|$gTempColor12|$gTempYesOrNo2|$gShowIPInfo|$gAlignType|$gTempColor8|$gTempURL9|$gTempURL4|$gTempURL5|$gTempURL6|$gTempURL7|$gTempURL8|$gTempYesOrNo6|$gTempYesOrNo5|$gTempYesOrNo4|\n";
    close(HANDLE);
    &unlock("$FORM{'db'}_cfg");
    
}

##########################################################################
# Ÿ оδ.
##########################################################################
sub read_data {
    require "./lib/cm_html_head.cgi";	
    	
    if($FORM{'p'}) {
        $gCurPage = $FORM{'p'};
    }
    else {
        $gCurPage = "1";
    }
    $gTotPage = int(($gNoOfData-1)/$gRecPerPage)+1;

    &html_head("bdr_guest");
    &MenuButton;
    &readIndexFile;
    &go_prev_next_page;
    &html_foot;
}

##########################################################################
# ޴
##########################################################################
sub MenuButton {
    print "
           <table width=$gTableWidth border=0 cellspacing=1 cellpadding=2 height=60>
            <tr>
            <td align=left align=top width=20%>
             <a href=bdr_guest.cgi?db=$FORM{'db'}&action=admin_login&p=$gCurPage&c=show_config_form><img src=$gIMG_Guest/admin.gif border=0 alt=\"Administrator\"></a>
             <a href=bdr_guest.cgi?db=$FORM{'db'}&action=show_user_input_form><img src=$gIMG_Guest/write.gif border=0 alt=\"Write\"></a>
            </td>
            <td width=60% align=center align=top>  <font color=red><b>$gNoOfData</b></font> ־.</td>
            <td align=right align=top width=20%>
           \n";
    
    $term = 1;
    $f = 1;
    $l = $term;
    while ($f <= $gTotPage) {
      if (($f <= $gCurPage) && ($gCurPage <= $l)) {
         $prevp = $f - 1;
        if ($prevp > 0) {
          print "<a href=bdr_guest.cgi?db=$FORM{'db'}&action=r&p=$prevp><img src=$gIMG_Guest/previous.gif border=0 alt=\"Previous Page\"></a> ";
        }
        else {
          print "<img src=$gIMG_Guest/previous_n.gif border=0 alt=\"First Page\"> ";
        }
       $nextp = $l + 1;
       if ($nextp <= $gTotPage) {
         print "<a href=bdr_guest.cgi?db=$FORM{'db'}&action=r&p=$nextp><img src=$gIMG_Guest/next.gif border=0 alt=\"Next Page\"></a>";
       }
       else {
         print "<img src=$gIMG_Guest/next_n.gif border=0 alt=\"Last Page\">";
       }
     }
     $f = $f + $term;
     $l = $l + $term;
   }

    print "
           </td></tr>
           </table>\n";
}

##########################################################################
# ȭ ŸϿ  
##########################################################################
sub readIndexFile {
    require "./lib/cm_get_date.cgi";
    	
    local($i,$j,$actual_number,$short_date);
    local(@datum,@data_fn,@value_fn,@value);

    &get_date;

    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
   
    print "<table border=0 width=$gTableWidth cellspacing=0 cellpadding=0 valign=top style=\"table-layout:fixed;\">\n";
    print "<tr><td>\n";
      
    for($i=($gCurPage-1)*$gRecPerPage+1;$i<=($gCurPage-1)*$gRecPerPage+$gRecPerPage;$i++) {
        @data_fn = split(/\|/,$datum[$i]);       
        if(-e "$gBaseDIR/data/$data_fn[1].cgi") {
            open(HANDLE, "<$gBaseDIR/data/$data_fn[1].cgi");
              @value_fn = <HANDLE>;
            close(HANDLE);              	
         }
             
        @value = split(/\|/, $value_fn[0]);               
        
        $actual_number = ($gNoOfData+1)-$i;

        if($actual_number > 0) {
           $date_length = length($date2);
           $short_date = substr($value[5],0,20);

#          ڵ HTML Ȱȭ
#          $value[6] =~ s/\|/&#124;/g;            
#          $value[6] =~ s/(http:\/\/)([\&\w\+\-\/\=\?\.\~]+)/$url <img src=$gIMG_Guest\/home.gif> <a href=\"$1$2\" target=\"_blank\">$1$2<\/a>/g;
#          $value[6] =~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/$mail <img src=$gIMG_Guest\/mail.gif> <a href=\"javascript:NewWin('200','200','309','338','mail','bdr_mail.cgi?fromname=$gSupervisor_Name&frommail=$gSupervisor_EMail&tomail=$1')\">$1<\/a>/g;
          
          # Ÿ1         
          if($gDesignType eq "style1") {
             print "<table border=1 cellpadding=0 cellspacing=0 width=100% align=center  bordercolorlight=#3E56a3 bordercolordark=#ffffff>\n<tr onMouseOver=this.style.backgroundColor=\"#f5f5f5\" onMouseOut=this.style.backgroundColor=\"\"><td>\n";
             print "<table border=0 cellpadding=0 cellspacing=0 width=100%>\n<tr><td colspan=2>\n";
             print "<table border=0 cellpadding=5 cellspacing=0 width=100%>\n";
               if($value[8] eq "http://" || $value[8] eq "") {
	   if($value[4] eq "") {
	      print "<tr><td><img src=$gIMG_Guest/sy1_home.gif border=0><font face=޸տü,ü color=#aa84FF>$value[2]</font>&nbsp;&nbsp;(<font color=#ff3344>$value[5]</font>)</td>\n";	
	   }
	   else {
	      print "<tr><td><img src=$gIMG_Guest/sy1_home.gif border=0><a href=\"javascript:NewWin('200','200','309','338','bdr_mail.cgi?fromname=$gSupervisor_Name&frommail=$gSupervisor_EMail&tomail=$value[4]')\"><font face=޸տü,ü color=#aa84FF>$value[2]</font></a>&nbsp;&nbsp;(<font color=#ff3344>$value[5]</font>)</td>\n";
	   }
	}
	else {
	   if($value[4] eq "") {
	      print "<tr><td><a href=$value[8] target=\"_blank\" title=\"$value[8]\"><img src=$gIMG_Guest/sy1_home.gif border=0></a><font face=޸տü,ü color=#aa84FF>$value[2]</font>&nbsp;&nbsp;(<font color=#ff3344>$value[5]</font>)</td>\n";
	   }
	   else {
              print "<tr><td><a href=$value[8] target=\"_blank\" title=\"$value[8]\"><img src=$gIMG_Guest/sy1_home.gif border=0></a><a href=\"javascript:NewWin('200','200','309','338','mail','bdr_mail.cgi?fromname=$gSupervisor_Name&frommail=$gSupervisor_EMail&tomail=$value[4]')\"><font face=޸տü,ü color=#aa84FF>$value[2]</font></a>&nbsp;&nbsp;(<font color=#ff3344>$value[5]</font>)</td>\n";
	   }	
        }
        print "<td align=right><a href=bdr_guest.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIMG_Guest/sy1_mod.gif border=0 alt=\"Modify\"></a><a href=bdr_guest.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIMG_Guest/sy1_del.gif border=0 alt=\"Delete\"></a><a href=bdr_guest.cgi?db=$FORM{'db'}&action=admin_login&p=$FORM{'p'}&c=show_reply_form&l=$value[1]><img src=$gIMG_Guest/sy1_reply.gif border=0 alt=\"Reply\"></a></td></tr>\n";
        print "<tr><td width=100% colspan=2><ul>";
	print "<font face=\"޸տü, ü\" color=black>$value[6]\n";
	print "</font></ul>\n";
        if ($value[9] ne "") {
	    print "<p><ul><img src=$gIMG_Guest/sy1_speak.gif border=0>&nbsp;<font color=#4455cc face=Ʒü,޸տü,ü>$value[2]Կ...</font><br><font color=#333355 face=Ʒü,޸տü,ü>$value[9]</font></ul><br>\n";
	}
        if($gShowIPInfo eq "checked") {
           print "     <div align=right><font size=1 color=aaaaaa>$value[7]</font>&nbsp;&nbsp;</div>\n";
        }	
	print "</td></tr></table>\n</td></tr></table>\n";
	print "</td></tr></table>\n";
	print "<br><br><center><table><tr><td background=$gIMG_Guest/sy1_line.gif border=0 width=$gTableWidth height=3></td></tr><table></center><br><br>\n";
          }
          # Ÿ1 

          # Ÿ2         
          elsif($gDesignType eq "style2"){
	print "<table border=0 cellpadding=0 cellspacing=0 width=100% align=center>\n";
	print "<tr><td background=\"$gIMG_Guest/sy2_tb1.gif\" height=6></td><td height=6 style=\"background-image:url($gIMG_Guest/sy2_tb2.gif); background-repeat:repeat-x; background-position:left top\"></td><td background=\"$gIMG_Guest/sy2_tb3.gif\" height=6></td></tr>\n";
	print "<tr><td width=6 style=\"background-image:url('$gIMG_Guest/sy2_tb2.gif'); background-repeat:repeat-y; background-position:left top\"></td>\n";
	print "<td><table border=0 cellpadding=9 cellspacing=7 width=100%>\n";
	if($value[8] eq "http://" || $value[8] eq "") {
	   if($value[4] eq "") {
	       print "<tr><td width=150 align=left>&nbsp;$actual_number.&nbsp;<b>$value[2]</b>&nbsp;&nbsp;&nbsp;</td><td align=right>&nbsp;<font color=aaaaaa size=1>$value[5]</font></td></tr>\n";
	   }	
	   else {
	       print "<tr><td width=150 align=left>&nbsp;$actual_number.&nbsp;<b>$value[2]</b>&nbsp;&nbsp;<a href=\"javascript:NewWin('200','200','309','338','mail','bdr_mail.cgi?fromname=$gSupervisor_Name&frommail=$gSupervisor_EMail&tomail=$value[4]')\"><img src=$gIMG_Guest/sy2_email.gif border=0></a>&nbsp;</td><td align=right>&nbsp;<font color=aaaaaa size=1>$value[5]</font></td></tr>\n";
	   }		
	}
	else {
	   if($value[4] eq "") {
	       print "<tr><td width=150 align=left>&nbsp;$actual_number.&nbsp;<b>$value[2]</b>&nbsp;&nbsp;<a href=\"$value[8]\" target=\"_blank\" title=\"$value[8]\"><img src=$gIMG_Guest/sy2_home.gif border=0></a></td><td align=right>&nbsp;<font color=aaaaaa size=1>$value[5]</font></td></tr>\n";
	   }	
	   else {
	       print "<tr><td width=150 align=left>&nbsp;$actual_number.&nbsp;<b>$value[2]</b>&nbsp;&nbsp;<a href=\"javascript:NewWin('200','200','309','338','mail','bdr_mail.cgi?fromname=$gSupervisor_Name&frommail=$gSupervisor_EMail&tomail=$value[4]')\"><img src=$gIMG_Guest/sy2_email.gif border=0></a>&nbsp;<a href=\"$value[8]\" target=\"_blank\" title=\"$value[8]\"><img src=$gIMG_Guest/sy2_home.gif border=0></a></td><td align=right>&nbsp;<font color=999999 size=1>$value[5]</font></td></tr>\n";
	   }		
	}			
	print "<tr><td width=100% colspan=2 align=left valign=bottom>";
	print "<table border=0><tr><td valign=top><img src=$gIMG_Guest/sy2_content.gif border=0></td><td>";
	print "<font color=#333333>$value[6]</font></td></tr></table>\n";
	if ($value[9] ne "") {
	    print "<p><ul><img src=$gIMG_Guest/sy2_speak.gif border=0>&nbsp;<font color=#555555 face=\"Ʒü,޸տü,ü\"><b>$value[2]</b>Կ...</font><br><font color=#222222 face=\"Ʒü,޸տü,ü\">$value[9]</font></ul><br>\n";
	}	
        if($gShowIPInfo eq "checked") {
           print "     <div align=right><font size=1 color=aaaaaa>$value[7]</font>&nbsp;&nbsp;</div>\n";
        }	
	print "<br><center><a href=bdr_guest.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIMG_Guest/sy2_mod.gif border=0 alt=\"Modify\"></a> <a href=bdr_guest.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIMG_Guest/sy2_del.gif border=0 alt=\"Delete\"></a> <a href=bdr_guest.cgi?db=$FORM{'db'}&action=admin_login&p=$FORM{'p'}&c=show_reply_form&l=$value[1]><img src=$gIMG_Guest/sy2_reply.gif border=0 alt=\"Reply\"></a></center></td></tr></table>\n";
	print "</td><td width=6 style=\"background-image:url('$gIMG_Guest/sy2_tb4.gif'); background-repeat:repeat-y; background-position:right top\"></td></tr>\n";
	print "<tr><td background=\"$gIMG_Guest/sy2_tb5.gif\" height=6></td><td height=6 style=\"background-image:url('$gIMG_Guest/sy2_tb6.gif'); background-repeat:repeat-x; background-position:left bottom\"></td><td background=\"$gIMG_Guest/sy2_tb7.gif\" height=6></td>\n";
	print "</tr></table>\n";
	print "<br><br>\n\n";
        }
          # Ÿ2 
          
          # Ÿ3 
          elsif($gDesignType eq "style3"){
	print "<table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td background=$gIMG_Guest/sy3_tb1.gif width=22 height=22></td><td background=$gIMG_Guest/sy3_tb5.gif ></td><td background=$gIMG_Guest/sy3_tb2.gif width=22 height=22></td></tr><tr><td background=$gIMG_Guest/sy3_tb7.gif></td><td>\n";
	if($value[4] eq "") {
                   print "<table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td><p align=left valign=bottom>&nbsp;<img src=$gIMG_Guest/sy3_an1.gif border=0>&nbsp;<font face=ü color=#ff3322>$value[2]</font><font color=#666666> <font color=#7fbb77>$value[5]</font>  ...</font></td><td width=70 align=right valign=bottom><a href=bdr_guest.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIMG_Guest/sy3_mod.gif border=0 alt=\"Modify\"></a><a href=bdr_guest.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIMG_Guest/sy3_del.gif border=0 alt=\"Delete\"></a><a href=bdr_guest.cgi?db=$FORM{'db'}&action=admin_login&p=$FORM{'p'}&c=show_reply_form&l=$value[1]><img src=$gIMG_Guest/sy3_reply.gif border=0 alt=\"Reply\"></a></td></tr>\n"
	}
	else {
                   print "<table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td><p align=left valign=bottom>&nbsp;<img src=$gIMG_Guest/sy3_an1.gif border=0>&nbsp;<a href=\"javascript:NewWin('200','200','309','338','mail','bdr_mail.cgi?fromname=$gSupervisor_Name&frommail=$gSupervisor_EMail&tomail=$value[4]')\"><font face=ü color=#ff3322>$value[2]</a></font><font color=#666666> <font color=#7fbb77>$value[5]</font>  ...</font></td><td width=70 align=right valign=bottom><a href=bdr_guest.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIMG_Guest/sy3_mod.gif border=0 alt=\"Modify\"></a><a href=bdr_guest.cgi?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIMG_Guest/sy3_del.gif border=0 alt=\"Delete\"></a><a href=bdr_guest.cgi?db=$FORM{'db'}&action=admin_login&p=$FORM{'p'}&c=show_reply_form&l=$value[1]><img src=$gIMG_Guest/sy3_reply.gif border=0 alt=\"Reply\"></a></td></tr>\n";	
	}
			
	if($value[8] eq "http://" || $value[8] eq "") {
                   print "<tr><td colspan=2><table border=0 cellpadding=5 cellspacing=0 width=100%><tr><td align=left>&nbsp;</td>\n";
	}
	else {
	   print "<tr><td colspan=2><table border=0 cellpadding=5 cellspacing=0 width=100%><tr><td align=left><img src=$gIMG_Guest/sy3_home.gif><a href=$value[8] target=\"_blank\"> <font face=ü color=#8866ff>$value[8]</font></a></td>\n";
               }			
	print "<td>&nbsp;</td></tr>\n";
	print "<tr><td colspan=2>";
	print "<font face=\"޸տü,ü,ü\" color=#444444>$value[6]</font>";
	if ($value[9] ne "") {
	    print "<p><ul><img src=$gIMG_Guest/sy3_speak.gif border=0>&nbsp;<font color=#ffaa66 face=\"޸տü,ü,ü\">$value[2]Կ...</font><br><font color=#44547f face=\"޸տü,ü,ü\">$value[9]</font></ul><br>\n";
	}
        if($gShowIPInfo eq "checked") {
           print "     <div align=right><font size=1 color=aaaaaa>$value[7]</font>&nbsp;&nbsp;</div>\n";
        }		
	print "</td></tr></table></td></tr></table>\n";
	print "</td><td background=$gIMG_Guest/sy3_tb8.gif></td></tr><tr><td background=$gIMG_Guest/sy3_tb3.gif width=22 height=22></td><td background=$gIMG_Guest/sy3_tb6.gif></td><td background=$gIMG_Guest/sy3_tb4.gif width=22 height=22></td></tr></table>\n";
	print "</div><br><center><img src=$gIMG_Guest/sy3_an2.gif><p></center>\n";          	
          }
          # Ÿ3 
       }
   }
   print "</td></tr></table>\n";
   
   unless($gNoOfData) {
        print "&nbsp;<table width=$gTableWidth border=0 cellspacing=1 cellpadding=6 align=center>\n";
        print "<tr align=center><td><font color=\"red\"><b> ϵ  ϴ.</font></b></td></tr></table>\n";
    }
}

##########################################################################
#  
##########################################################################
sub go_prev_next_page {
       print "<table border=0 cellpadding=9 cellspacing=1 align=center valign=top><tr><td align=center>\n";
       $term = $gListNumber;
       $f = 1;
       $l = $term;
       
       while ($f <= $gTotPage) {
          if(($f <= $gCurPage) && ($gCurPage <= $l)) {
            $prevp = $f - 1;

            if ($prevp > 0) {
               print "<a href=bdr_guest.cgi?db=$FORM{'db'}&action=r&p=$prevp>[ ]</a>..";
            }
          
            if ($l <= $gTotPage) {
	for ($page = $f; $page <= $l; $page++) {
	   if ($page == $gCurPage) {
                      print "<font color=$gTableText>[<font color=blue><b>$page</b></font>]</font>";
	   }
                   else {
                     print "<a href=bdr_guest.cgi?db=$FORM{'db'}&action=r&p=$page>[$page]</a>";
                   }
               }
            }
            else {
               for ($page = $f; $page <= $gTotPage; $page++) {
	 if ($page == $gCurPage) {
                   print "<font color=$gTableText>[<font color=blue><b>$page</b></font>]</font>";
                 }
                 else {
                  print "<font color=$gTextColor><a href=bdr_guest.cgi?db=$FORM{'db'}&action=r&p=$page>[$page]</font></a>";
                 }
           }
        }
        $nextp = $l + 1;
        
        if ($nextp <= $gTotPage) {
           print "..<a href=bdr_guest.cgi?db=$FORM{'db'}&action=r&p=$nextp>[ ]</a>";
        }
     }
     $f = $f + $term;
     $l = $l + $term;
   }
   print "</td></tr></table>\n";
}

##########################################################################
#  ۾ 
##########################################################################
sub show_user_input_form {
    require "./lib/cm_html_head.cgi";	
    require "./lib/cm_get_date.cgi";    	
    require "./lib/cm_get_cookie.cgi";    
        
    local($data,$subject,$content,$name,$value);
    local(@value,@cookies);

    &get_date; 
    &get_cookie;
    &html_head("bdr_guest");
    print "<form method=post name=inputForm action=bdr_guest.cgi>\n";    
    print "<br><table border=1 width=450 bgcolor=#eeeeee bordercolorlight=#cccccc bordercolordark=#ffffff cellspacing=0 cellpadding=5 align=center>\n";   
    print "<tr><td align=center>\n";

    print "<table border=0 cellspacing=1 cellpadding=2>\n";    
    print "<input type=hidden name=db value=$FORM{'db'}>\n";
    print "<input type=hidden name=action value=write>\n";
    print "<input type=hidden name=p value=1>\n";
    
    print "<tr><td align=right><span class=cls><b>Password</b></span></td>\n";
    print "<td><input type=password name=passwd size=53 maxlength=16 class=text></td></tr>\n";
    print "<tr><td align=right><span class=cls><b>Name</b></span></td><td>\n";
    print "<input name=name value='' type=text size=53 value='' class=text>\n";
    print "</td></tr>\n";    
    print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
    print "<input name=email value='' type=text size=53 class=text></td></tr>\n";                    
    print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
    print "<input name=homepage type=text value='http://' size=45 class=text> <input type=checkbox name=html value=checked style=\"background-color:#eeeeee;border:0\">html\n";
    print "<input type=hidden name=phone value=\"$value[3]\">\n";                             # Ӽ : ó
    print "<input type=hidden name=reply value=\"$value[9]\">\n";                              # Ӽ : ۴ޱ    
    print "<input type=hidden name=ip value=\"$value[7]\">\n";                              # Ӽ : ip    
    print "<input type=hidden name=date value=\"$value[5]\">\n";                              # Ӽ : ¥            
    print "</td></tr>\n";         
    print "<tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=15 cols=52 class=comment></textarea></td>\n";
    print "</tr>\n";
    print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
    print "</tr></table>\n";
    print "</td></tr></table>\n";
    print "</form>\n";
    print "<script language=\"javascript\">document.inputForm.passwd.focus();</script>\n";
    &html_foot;
}

##########################################################################
# ȭϿ Է  Ѵ.
##########################################################################
sub write_data {
    require "./lib/cm_make_crypt_password.cgi";
    require "./lib/cm_get_num_info.cgi";
    require "./lib/cm_put_num_info.cgi";
	
    &get_num_info;
    &getVariable;   
    &make_crypt_password if($passwd);  
    &makeNewFile;
    &appendIndexFile;
    $gNoOfData++;
    &put_num_info($gNoOfData);

    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<meta http-equiv=refresh content=0;url=bdr_guest.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
    print "</html>\n";
}

##########################################################################
# Է  ´
##########################################################################
sub getVariable {
    require "./lib/cm_alert.cgi";
	
# ȣ	
    if(($FORM{'passwd'}) || ($FORM{'OldPassword'})) {
        $passwd = "$FORM{'passwd'}";
    }
    else {
        $msg = "ȣ ݵ ּ."; 
        alert($msg);
    }
    
# ̸
    unless($FORM{'name'} =~ /^\s*$/) {
        $name = "$FORM{'name'}";
        $name =~ s/\|/&#124;/g;
        $name =~ s/\r\n/<br>/g;
    }
    else {
        $msg = "̸ ݵ ּ."; 
        alert($msg);
    }

# ϰ 
    if($FORM{'content'}) {
       $content = "$FORM{'content'}";
        if($FORM{'html'} ne "checked") {
            $content =~ s/</&lt;/g;
            $content =~ s/>/&gt;/g;
            $content =~ s/"/&quot;/g;
        }
        $content =~ s/\|/&#124;/g;
        $content =~ s/\r\n\r\n/<p>/g;
        $content =~ s/\r\n/<br>/g;
    }
    else {
        $msg = " ݵ ּ."; 
        alert($msg);
    }

# ۴ޱ
    if($FORM{'reply'}) {
       $reply = "$FORM{'reply'}";
       $reply =~ s/\r\n/<br>/g;
       $reply =~ s/\|/&#124;/g;
    }
    
# ̸
    if($FORM{'email'}) {
        $email = "$FORM{'email'}";
        $email =~ s/\|/&#124;/g;
    }
    else {
        $email = "";
    }
    
# Ȩ
    if($FORM{'homepage'}) {
       if($FORM{'homepage'} eq 'http://') {
       	  $homepage = "";
       }
       else {
          $homepage = "$FORM{'homepage'}";
          $homepage =~ s/\|/&#124;/g;
        }
    }

# ó
    if($FORM{'phone'}) {
        $phone = "$FORM{'phone'}";
        $phone =~ s/\|/&#124;/g;
    }
    else {
        $phone = "";
    }

# ¥
    if($FORM{'date'} eq "") {
        require "./lib/cm_get_date.cgi";    	
        &get_date;  
    }
    else {
        $date2 = "$FORM{'date'}";
        $date2 =~ s/\|/&#124;/g;
    }
    
    if($FORM{'ip'} eq "") {
        $ip = $ENV{'REMOTE_ADDR'};
    }
    else {
        $ip = "$FORM{'ip'}";
        $ip =~ s/\|/&#124;/g;
    }        
}

##########################################################################
# 亯 Ϻ
##########################################################################
sub ReplyMail {   
    open(MAIL,"|$gSENDMAIL -t $FORM{'email'}");
    print MAIL "To: $FORM{'email'}\n";
    print MAIL "From: $gSupervisor_Name<$gSupervisor_EMail>\n";
    print MAIL "Subject: Ͽ  ּż մϴ.\n";
    print MAIL "Content-Type: text/html\n\n";
    print MAIL "
	<html>
	<head>
	<title>A Replied Message From GuestBook Of $gSupervisor_Homepage</title>
                <style type=text/css>
                    <!--
                    body,table,tr,td,select,input,div,form,textarea {font-family:,,verdana; font-size:9pt; color:black; line-height:12pt}
                    A:link {text-decoration:none; color:#000066;}
                    A:visited {text-decoration:none}
                    A:hover {  text-decoration:none; color:#ffee33;}
                    p,br,body,td,input,form,textarea,option {font-size:9pt;}
                    -->
                </style>
                </head>\n";
                
    $content = $FORM{'content'};
    $replycontent = $FORM{'reply'};
    $content =~ s/<br>/\n/g;
    $content =~ s/<p>/\n\n/g;                
    $replycontent =~ s/<br>/\n/g;
    $replycontent =~ s/<p>/\n\n/g;                    
    
     print MAIL "<body bgcolor=ffffff oncontextmenu='return true'>
           	      <table border=1 cellPadding=3 cellSpacing=1 width=500 bordercolorlight=#000000 bordercolordark=#ffffff align=center style=\"table-layout:fixed;\">
         	       <tr>
         	        <td align=right><a href=$gSupervisor_Homepage target=_blank>$gSupervisor_Homepage</a></td>
         	       </tr>
         	       <tr>
         	        <td align=left style='word-break:break-all;'>
         	        <b>$FORM{'name'}  </b><br>
         	        <pre>$content
         	        </pre>
         	        </td>
         	       </tr>
         	       <tr>
         	        <td align=left>
         	        <b>$gSupervisor_Name 亯 </b><br>
         	        <pre>$replycontent
         	        </pre>
         	        </td>
         	       </tr>         	                	                	       
    	        </table></div>\n";
	print MAIL "<br><br></body></html>\n";
	close (MAIL);
}

##########################################################################
#  α δ
##########################################################################
sub show_user_ogin {
    require "./lib/cm_html_head.cgi";	
    	
    local($command);

    if($FORM{'c'} eq "delete") {
        $command = "delete";
    }
    else {
        $command = "show_update_form";
    }
       
    &html_head("bdr_guest");   
    print "<TABLE WIDTH=220 valign=top align=center border=0 background=$gIMG_Guest/m_bg.gif>\n";    
    print "<tr><td align=center valign=top>\n";        	
    print "<form method=post name=userlogin action=bdr_guest.cgi>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=action value=$command>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print "<center><br><b> </b><br><br><center>\n" if($command eq "delete");
    print "<center><br><b> </b><br><br><center>\n" if($command eq "show_update_form");
    print "<input type=hidden name=ps value=old>\n";   
    print "<font color=$gTextColor>йȣ </font>\n";
    print "<input type=password name=passwd size=12 maxlength=16> \n";
    print "</td></tr>\n";
    print "<tr><td align=right valign=top>\n";    
    print "<input type=submit value=\" Ȯ  \">\n";
    print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";    
    print "</form>\n";
    print "<br><br><br><br></td></tr></table>\n";    
    print "<script language=\"javascript\">document.userlogin.passwd.focus();</script>\n";                         
    &html_foot;       
}

##########################################################################
# ϵ ȭ Ѵ
##########################################################################
sub delete_data {
    require "./lib/cm_lock.cgi";
    require "./lib/cm_get_num_info.cgi";    
    require "./lib/cm_put_num_info.cgi";
	
    local(@datum,@value);
 
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
    
    &lock("$FORM{'db'}_data");    
    open(HANDLE,">$gBaseDIR/$gDatFile");
    foreach $data (@datum) {
        @value = split(/\|/, $data);
        if($FORM{'l'} != $value[1]) {
            print HANDLE "$data";             
        }
    }
    close(HANDLE);
    &unlock("$FORM{'db'}_data");
    
    unlink("$gBaseDIR/data/$FORM{'l'}.cgi");

    &get_num_info;
    $gNoOfData--;
    &put_num_info($gNoOfData);

    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<meta http-equiv=refresh content=0;url=bdr_guest.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
    print "</html>\n";
}

##########################################################################
# ϵ ȭ  Ʈ 
##########################################################################
sub show_update_form {
    require "./lib/cm_html_head.cgi";	
    require "./lib/cm_get_cookie.cgi";     
        	
    local($data,$name,$value);
    local(@cookies);

    &get_cookie;
 
    open(HANDLE,"$gBaseDIR/data/$FORM{'l'}.cgi");
        $data = <HANDLE>;
    close(HANDLE);
    @value = split(/\|/,$data);             

    &html_head("bdr_guest");

    print "<br><table border=1 width=450 bgcolor=#eeeeee bordercolorlight=#cccccc bordercolordark=#ffffff cellspacing=0 cellpadding=5 align=center>\n";    
    print "<tr><td align=center>\n";    
    print "<form method=post name=updateform action=bdr_guest.cgi>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
    print "<input type=hidden name=action value=update>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print "<input type=hidden name=OldPassword value=$value[0]>\n";

    print "<table border=0 cellspacing=1 cellpadding=2>\n";    
    print "<tr><td align=right><span class=cls><b>Name</b></span></td><td>\n";
    $value[2] =~ s/<br>/\n/g;
    print "<input name=name value=\"$value[2]\" type=text size=53 value='' class=text></td></tr>\n";
    print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
    print "<input type=hidden name=phone value=\"$value[3]\">\n";                             # Ӽ : ó
    print "<input type=hidden name=reply value=\"$value[9]\">\n";                               # Ӽ : ۴ޱ
    print "<input name=email value=\"$value[4]\" type=text size=53 class=text></td></tr>\n";               
    print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
    print "<input name=homepage type=text value=\"$value[8]\" size=45 type=text class=text> <input type=checkbox name=html value=checked style=\"background-color:#eeeeee;border:0\">html</td></tr>\n";
    $value[6] =~ s/<br>/\n/g;
    $value[6] =~ s/<p>/\n\n/g;
    print "<tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=15 cols=53 class=comment>$value[6]</textarea></td>\n";
    print "</tr><tr>\n";
    print "<td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
    print "</tr></table>\n";
    print "</td></tr></table>\n";
    print "</form>\n";
    print "<script language=\"javascript\">document.updateform.content.focus();</script>\n";
    &html_foot;       
}

##########################################################################
# ϵ ȭ  ۴ޱ 
##########################################################################
sub showReplyForm {
    require "./lib/cm_html_head.cgi";	
    require "./lib/cm_get_cookie.cgi"; 
        	
    local($data,$name,$value);

    &get_cookie;
 
    open(HANDLE,"$gBaseDIR/data/$FORM{'l'}.cgi");
        $data = <HANDLE>;
    close(HANDLE);
    @value = split(/\|/,$data);             

    &html_head("bdr_guest");

    print "<br><table border=1 width=500 bgcolor=#eeeeee bordercolorlight=#cccccc bordercolordark=#ffffff cellspacing=0 cellpadding=5 align=center>\n";    
    print "<tr><td align=center>\n";    
    print "<form method=post name=replyform action=bdr_guest.cgi>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
    print "<input type=hidden name=action value=update>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print "<input type=hidden name=OldPassword value=$value[0]>\n";

    print "<table border=0 width=$gTableWidth cellspacing=2 cellpadding=0 valign=top align=center style=\"table-layout:fixed;\">\n";
    $value[2] =~ s/<br>/\n/g;
    $value[2] =~ s/<p>/\n\n/g;
    print "<tr><td width=100 align=right style='word-break:break-all;'><span class=cls><b>Name</b></span></td>";
    print "<td><input name=name type=text class=text size=53 value=\"$value[2]\" readonly></td></tr>\n";
    print "<input type=hidden name=phone value=\"$value[3]\">\n";
    print "<input name=email value=\"$value[4]\" type=hidden size=40>\n";    
    print "<input name=homepage type=hidden value=\"$value[8]\" size=40 type=text></td></tr>\n";
    print "<input type=hidden name=ip value=\"$value[7]\">\n";                              # Ӽ : ip    
    print "<input type=hidden name=date value=\"$value[5]\">\n";                              # Ӽ : ¥                
    print "<input type=hidden name=html value=checked checked>\n";    
    $value[6] =~ s/<br>/\n/g;
    $value[6] =~ s/<p>/\n\n/g;       
    print "<tr><td align=right valign=top><span class=cls><b>Comment</b></span></td>
           <td><table width=340 bgcolor=f5f5f5 style=\"table-layout:fixed;\"><tr><td><input type=hidden name=content value=\"$value[6]\">$value[6]</td></tr></table></td></tr>\n";
    $value[9] =~ s/<br>/\n/g;
    $value[9] =~ s/<p>/\n\n/g;           
    print "<tr><td align=right valign=top><span class=cls><b>Reply</b></span></td><td><textarea name=reply rows=15 cols=53 class=comment>$value[9]</textarea></td></tr>\n";
    if($value[4]) {
      print "<tr><td>&nbsp;</td><td align=left valign=top><input type=checkbox name=replymail value=checked checked style=\"background-color:#eeeeee;border:0\"><a href=\"mailto:$value[4]\" title=$value[4]><font color=#999999>$value[2]</font></a><font color=#aaaaaa>Կ 亯 Ϻ</font></td></tr>\n";
    }        
    print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
    print "</tr></table>\n";
    print "</td></tr></table>\n";
    print "</form>\n";
    print "<script language=\"javascript\">document.replyform.reply.focus();</script>\n";
    &html_foot;       
}

##########################################################################
#  ȭ Ѵ
##########################################################################
sub makeNewFile { 
    require "./lib/cm_lock.cgi";
    require "./lib/cm_get_date.cgi";
    
    local(@set);

    &get_date;

    @set = ('0'..'9'); 
    srand(time);
    $gRandomFilename = "$d$set[rand(10)]$set[rand(10)]$set[rand(10)]$set[rand(10)]$set[rand(10)]$set[rand(10)]";
    open(HANDLE,">$gBaseDIR/data/$gRandomFilename.cgi");
        print HANDLE "$gCryptPassword|$gRandomFilename|$name|$phone|$email|$date2|$content|$ip|$homepage|$reply|$Items||||||\n";
    close(HANDLE);
}

##########################################################################
# ȭϿ  Ѵ
##########################################################################
sub appendIndexFile {
    require "./lib/cm_lock.cgi";
    	
    local($data);
    local(@datum,@point);

    &lock("$FORM{'db'}_data");
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
    
    if($FORM{'l'}) {    # 亯 ߰ 
        open(HANDLE,">$gBaseDIR/$gDatFile");
        foreach $data (@datum) {
            @point = split(/\|/,$data);
            if($point[1] eq $FORM{'l'}) {
                $thread = $point[0] + 1;
                print HANDLE "$data";
	    print HANDLE "$thread|$gRandomFilename|\n";	    
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
     }
     else {
        open(HANDLE,">$gBaseDIR/$gDatFile");
        foreach $data (@datum) {
            if($data =~ /<!--EOF-->/) {
                print HANDLE "<!--EOF-->\n";
	        print HANDLE "0|$gRandomFilename|\n";	    
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
    }
    &unlock("$FORM{'db'}_data");
}

##########################################################################
# Ʈ  ϵ ȭ ã Ѵ
##########################################################################
sub update_data {
    require "./lib/cm_lock.cgi";
    	
    local(@datum,@value);

    &getVariable;
    
    if($FORM{'replymail'} eq "checked") {
       &ReplyMail;
    }
   
    &lock("$FORM{'db'}_data");   
    open(HANDLE,"<$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);

    open(HANDLE,">$gBaseDIR/$gDatFile");
    foreach $data (@datum) {
        @value = split(/\|/,$data);
        if($FORM{'l'} eq $value[1]) {
#                                      0       |ȣ            |
            print HANDLE "$value[0]|$FORM{'l'}|\n";
        }
        else {
            print HANDLE "$data";
        }
    }
    close(HANDLE);
   &unlock("$FORM{'db'}_data");  

    &lock("$FORM{'db'}_data2");       
    open(HANDLE,">$gBaseDIR/data/$FORM{'l'}.cgi");
#                                               ȣ            |ȭϸ        |̸|ó|̸|¥  |       |ip|Ȩ      |      |||||||
     print HANDLE "$FORM{'OldPassword'}|$FORM{'l'}|$name|$phone|$email|$date2|$content|$ip|$homepage|$reply|$Items||||||\n";
    close(HANDLE);
    &unlock("$FORM{'db'}_data2");

    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<meta http-equiv=refresh content=0;url=bdr_guest.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
    print "</html>\n";
}

##########################################################################
#  α
##########################################################################
sub show_admin_login {
    require "./lib/cm_html_head.cgi";	

    local($command);

    if($FORM{'c'} eq "show_reply_form") {
        $command = "show_reply_form";
    }
    
    &html_head("bdr_guest");
    unless(open(HANDLE,"$gBaseDIR/$gPwdFile")) {
        print "<table width=220 valign=top align=center border=0 background=$gIMG_Guest/m_bg.gif>\n";
        print "<tr><td align=center valign=top>\n";        	
        print "<br><form action=bdr_guest.cgi name=passwdconfig>\n";
        print "<input type=hidden name=db value=$FORM{'db'}>\n";    
        print "<input type=hidden name=action value=$FORM{'c'}>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=new>\n";
        print "<b> йȣ </b><br><br>\n";
        print "<table border=0 width=150>\n";
        print "<tr><td width=50 align=left>йȣ</td><td align=left><input type=password name=newpasswd size=12 maxlength=16></td></tr>\n";
        print "<tr><td width=50 align=left>  </td><td align=left><input type=password name=repasswd size=12 maxlength=16></td></tr>\n";
        print "<tr><td width=50></td><td align=right><input type=submit value=\" Ȯ \">&nbsp;&nbsp;&nbsp;</td></tr>\n";
        print "</table>\n";
        print "</font></form>\n";
        print "<br></td></tr></table>\n";            
        print "<script language=\"javascript\">document.passwdconfig.newpasswd.focus();</script>\n";                        
    }
    else {
        print "<table width=220 valign=top align=center border=0 background=$gIMG_Guest/m_bg.gif>\n";
        print "<tr><td align=center valign=top>\n";        	    	
        print "<br><form method=post name=config action=bdr_guest.cgi>\n";
        print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
        print "<input type=hidden name=action value=$FORM{'c'}>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=old>\n";
        print "<input type=hidden name=l value=$FORM{'l'}>\n";        
        print "<b>ڸ";
        print "&nbsp;(庸)" if($command eq "show_reply_form");        
        print "</b><br>\n";      
        print "<input type=hidden name=action value=$FORM{'c'} checked style=\"background-color:#ffffff;border:1 solid white\">\n";
        print "<br>йȣ&nbsp;<input type=password name=oldpasswd size=12 maxlength=16>\n";
        print "</td></tr>\n";
        print "<tr><td align=right valign=top>\n";                    
        print " <input type=submit value=\" Ȯ \">\n";
        print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";            
        print "</form>\n";
        print "<br><br><br><br></td></tr></table>\n";                    
        print "<script language=\"javascript\">document.config.oldpasswd.focus();</script>\n";
    }
    close(HANDLE);
    &html_foot;    
}

##########################################################################
# ڿ  ȯ漳
##########################################################################
sub show_config_form {
    require "./lib/cm_html_head.cgi";	
    	
    &html_head("bdr_guest");
    print "<table bgcolor=#000000 border=0 width=500 align=$gAlignType cellspacing=1 cellpadding=0><tr><td bgcolor=#ffffff>\n";    
    print "<br><b><font color=\"3355cc\"><center>Configuration For <b>$gSupervisor_HomeName</b></center></font></b><br><br>\n";
    print "<table border=0 width=100% align=center cellspacing=3 cellpadding=3><tr><td>\n";
    print "<form action=bdr_guest.cgi>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n";
    print "<input type=hidden name=action value=config>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=ps value=new>\n";

# DB 
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: DB :: </b></td></tr>\n";
    print "<tr><td align=left>CGI Ÿ</td><td align=right><font color=#777777><b> </b></font></td></tr>\n";    
    print "<tr><td align=left>Design Style</td>\n";
    print "<td align=right><select name=DesignType>\n";
    if($gDesignType eq "style1") {
        print "<option value=style1 selected>Ÿ1";
        print "<option value=style2>Ÿ2";
        print "<option value=style3>Ÿ3&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    elsif($gDesignType eq "style2") {
        print "<option value=style1>Ÿ1";
        print "<option value=style2 selected>Ÿ2";
        print "<option value=style3>Ÿ3&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    elsif($gDesignType eq "style3") {
        print "<option value=style1>Ÿ1";
        print "<option value=style2>Ÿ2";
        print "<option value=style3 selected>Ÿ3&nbsp;&nbsp;&nbsp;&nbsp;";
    }    
    print "</select></td></tr>\n";
    print "</table><br>\n";

# йȣ     
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: йȣ  :: </b></td></tr>\n";
    print "<tr align=right><td align=left>йȣ</td><td align=right><input type=password name=newpasswd size=12 maxlength=16></td></tr>\n";
    print "<tr align=right><td align=left>Է</td><td align=right><input type=password name=repasswd size=12 maxlength=16>\n";
    print "</td></tr></table><br>\n";

######
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> ::  :: </b></td></tr>\n";

    print "<tr><td align=left></td>\n";
    print "<td align=right>";
    if($gTitleUse eq "YES") {         #  ȣȯ ؼ 
       $gTitleUse = "checked";
    }
    print "<input type=checkbox name=TitleUse value=checked $gTitleUse style=\"background-color:#ffffff;border:0\">̱\n";
    print "</td></tr>\n";   
    
    print "<tr><td align=left>ڻ</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTextColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TextColor value=\"$gTextColor\" size=10></td></tr>\n";
    print "<tr><td align=left></td><td align=right><table border=1  bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gBackColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=BackColor value=\"$gBackColor\" size=10></td></tr>\n";
    print "<tr><td align=left> ̹ URL</td><td align=right><input type=text name=BackImgURL value=\"$gBackImgURL\" size=50></td></tr>\n";
    print "</table><br>\n";

### ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> ::   :: </b></td></tr>\n";

    print "<tr><td align=left>̺ </td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableBgcolor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TableBgcolor value=\"$gTableBgcolor\" size=10></td></tr>\n";
    print "<tr><td align=left>̺ ڻ</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" bgcolor=black cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableText\">&nbsp;&nbsp;</td></tr></table><input type=text name=TableText value=\"$gTableText\" size=10></td></tr>\n";    
    print "<tr><td align=left>콺 ġ Խù </td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gActiveTableColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=ActiveTableColor value=\"$gActiveTableColor\" size=10></td></tr>\n";
    print "</table><br>\n";

###Display ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: Display  :: </b></td></tr>\n";
    print "<tr><td align=left>IP</td>\n";
    print "<td align=right>";
    print "<input type=checkbox name=ShowIPInfo value=checked $gShowIPInfo style=\"background-color:#ffffff;border:0\">̱\n";    
    print "</td></tr>\n";                
    print "<tr><td align=left>Ĺ</td><td align=right><select name=AlignType>\n";
    if($gAlignType eq "left") {
        print "<option value=left selected>Left";
        print "<option value=center>Center";
        print "<option value=right>Right&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }    
    elsif($gAlignType eq "center" || $gAlignType eq "") {
        print "<option value=left>Left";
        print "<option value=center selected>Center";
        print "<option value=right>Right&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    elsif($gAlignType eq "right") {
        print "<option value=left>Left";
        print "<option value=center>Center";
        print "<option value=right selected>Right&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }    
    print "</select></td></tr>\n";        
    print "<tr><td align=left>̺ ũ</td><td align=right><input type=text name=TableWidth value=\"$gTableWidth\" size=12 maxlength=4></td></tr>\n";
    print "<tr><td align=left>ȭ Խùϼ</td><td align=right><input type=text name=RecPerPage value=\"$gRecPerPage\" size=12 maxlength=2></td></tr>\n";
    print "<tr><td align=left>ȭ  ̵ ϼ</td><td align=right><input type=text name=ListNumber value=\"$gListNumber\" size=12 maxlength=2></td></tr>\n";
    print "</table><br>\n";
    print "</td></tr></table>\n";
    print "</td></tr></table><br><br>\n";

    print "<center><input type=submit value=\" Ȯ  \">\n";
    print "</form>\n";

    &html_foot;
}

##########################################################################
# ȯ漳 ƮѴ
##########################################################################
sub update_config_variables {
    require "./lib/cm_check_password.cgi";
	
    &check_admin_password if($FORM{'newpasswd'} || $FORM{'repassword'});

    $gDesignType = $FORM{'DesignType'};
    $gBackColor = $FORM{'BackColor'};
    $gTextColor = $FORM{'TextColor'};
    $gBackImgURL = $FORM{'BackImgURL'};
    $gTempURL3 = $FORM{'TitleText'};
    $gTempURL2 = $FORM{'TempURL2'} if($FORM{'TempURL2'} =~ /^http:\/\// || $FORM{'TempURL2'} eq "");
    $gTempColor1 = $FORM{'TempColor1'};
    $gTempColor2 = $FORM{'TempColor2'};
    $gTempColor7 = $FORM{'TempColor7'};

    $gTableText = $FORM{'TableText'};

    $gTableWidth = $FORM{'TableWidth'};         
    $gRecPerPage = $FORM{'RecPerPage'} if($FORM{'RecPerPage'} >= 1);

    $gListNumber = $FORM{'ListNumber'};
    $gActiveTableColor = $FORM{'ActiveTableColor'};
    $gAlignType = $FORM{'AlignType'};
    $gTitleUse = $FORM{'TitleUse'};    
    $gTableBgcolor = $FORM{'TableBgcolor'};
    
    $gTempColor3 = $FORM{'TempColor3'};        
    $gTempColor4 = $FORM{'TempColor4'};
    $gTempColor8 = $FORM{'TempColor8'};    
    $gTempColor9 = $FORM{'TempColor9'};
    $gTempColor11 = $FORM{'TempColor11'};
    $gTempColor12 = $FORM{'TempColor12'};    
    $gTempNum1 = $FORM{'TempNum1'};    
    $gTempURL4 = $FORM{'TempURL4'};
    $gTempURL5 = $FORM{'TempURL5'};
    $gTempURL6 = $FORM{'TempURL6'};
    $gTempURL7 = $FORM{'TempURL7'};
    $gTempURL8 = $FORM{'TempURL8'};
    $gTempURL9 = $FORM{'TempURL9'};    
    $gTempYesOrNo1 = $FORM{'TempYesOrNo1'};
    $gTempYesOrNo2 = $FORM{'TempYesOrNo2'};
    $gShowIPInfo = $FORM{'ShowIPInfo'};    
    $gTempYesOrNo4 = $FORM{'TempYesOrNo4'};
    $gTempYesOrNo5 = $FORM{'TempYesOrNo5'};
    $gTempYesOrNo6 = $FORM{'TempYesOrNo6'};
        
    &putEnvVar;
    $gCurPage = $FORM{'p'};

    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<meta http-equiv=refresh content=\"0;url=bdr_guest.cgi?db=$FORM{'db'}&action=r&p=$FORM{'p'}\">\n";
    print "</html>\n";
}

#
#value0 = 0
#value1 = ȭ
#value2 = ̸/
#value3 = ó
#value4 = ̸
#value5 = ð
#value6 = 
#value7 = IP
#value8 = Ȩ
#value9 = 
#value10 = 
#value11 = 
#value12 = 
#value13 = 
#value14 = 
#value15 = 